#ifndef __CFM_OPENGL_BRIDGE__
#define __CFM_OPENGL_BRIDGE__

#include <glext.h>

#ifdef __cplusplus
extern "C" {
#endif

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
#define GL_ARB_occlusion_query              1
#define GL_ARB_shader_objects               1
#define GL_ARB_vertex_shader                1
#define GL_ARB_fragment_shader              1
#define GL_ARB_shading_language_100         1
#define GL_ARB_vertex_buffer_object         1
#define GL_ARB_point_sprite                 1
#define GL_ARB_texture_non_power_of_two     1
#define GL_ARB_texture_rectangle            1
#define GL_ARB_draw_buffers                 1
#define GL_ARB_pixel_buffer_object          1

#define GL_EXT_separate_specular_color      1

#define GL_EXT_depth_bounds_test            1
#define GL_EXT_blend_equation_separate      1
#define GL_EXT_texture_mirror_clamp         1
#define GL_EXT_texture_compression_dxt1     1
#define GL_EXT_framebuffer_object           1

#define GL_APPLE_flush_render               1
#define GL_APPLE_pixel_buffer               1

#define GL_ATI_separate_stencil             1
#define GL_ATI_array_rev_comps_in_4_bytes   1
#define GL_ATI_texture_compression_3dc      1
#define GL_ATI_texture_float                1

#define GL_NV_fragment_program_option       1
#define GL_NV_fragment_program2             1
#define GL_NV_vertex_program2_option        1
#define GL_NV_vertex_program3               1
#define GL_SGI_color_matrix                 1


//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
#if GL_ARB_shader_objects
typedef char GLcharARB;
typedef void *GLhandleARB;
#endif

#if GL_ARB_vertex_buffer_object
typedef long GLintptrARB;
typedef long GLsizeiptrARB;
#endif

/*************************************************************/

#if GL_ARB_occlusion_query
#define GL_SAMPLES_PASSED_ARB             0x8914
#define GL_QUERY_COUNTER_BITS_ARB         0x8864
#define GL_CURRENT_QUERY_ARB              0x8865
#define GL_QUERY_RESULT_ARB               0x8866
#define GL_QUERY_RESULT_AVAILABLE_ARB     0x8867
#endif

#if GL_ARB_shader_objects
#define GL_PROGRAM_OBJECT_ARB                              0x8B40
#define GL_OBJECT_TYPE_ARB                                 0x8B4E
#define GL_OBJECT_SUBTYPE_ARB                              0x8B4F
#define GL_OBJECT_DELETE_STATUS_ARB                        0x8B80
#define GL_OBJECT_COMPILE_STATUS_ARB                       0x8B81
#define GL_OBJECT_LINK_STATUS_ARB                          0x8B82
#define GL_OBJECT_VALIDATE_STATUS_ARB                      0x8B83
#define GL_OBJECT_INFO_LOG_LENGTH_ARB                      0x8B84
#define GL_OBJECT_ATTACHED_OBJECTS_ARB                     0x8B85
#define GL_OBJECT_ACTIVE_UNIFORMS_ARB                      0x8B86
#define GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB            0x8B87
#define GL_OBJECT_SHADER_SOURCE_LENGTH_ARB                 0x8B88
#define GL_SHADER_OBJECT_ARB                               0x8B48
#define GL_FLOAT_VEC2_ARB                                  0x8B50
#define GL_FLOAT_VEC3_ARB                                  0x8B51
#define GL_FLOAT_VEC4_ARB                                  0x8B52
#define GL_INT_VEC2_ARB                                    0x8B53
#define GL_INT_VEC3_ARB                                    0x8B54
#define GL_INT_VEC4_ARB                                    0x8B55
#define GL_BOOL_ARB                                        0x8B56
#define GL_BOOL_VEC2_ARB                                   0x8B57
#define GL_BOOL_VEC3_ARB                                   0x8B58
#define GL_BOOL_VEC4_ARB                                   0x8B59
#define GL_FLOAT_MAT2_ARB                                  0x8B5A
#define GL_FLOAT_MAT3_ARB                                  0x8B5B
#define GL_FLOAT_MAT4_ARB                                  0x8B5C
#define GL_SAMPLER_1D_ARB                                  0x8B5D
#define GL_SAMPLER_2D_ARB                                  0x8B5E
#define GL_SAMPLER_3D_ARB                                  0x8B5F
#define GL_SAMPLER_CUBE_ARB                                0x8B60
#define GL_SAMPLER_1D_SHADOW_ARB                           0x8B61
#define GL_SAMPLER_2D_SHADOW_ARB                           0x8B62
#define GL_SAMPLER_2D_RECT_ARB                             0x8B63
#define GL_SAMPLER_2D_RECT_SHADOW_ARB                      0x8B64
#endif

#if GL_ARB_vertex_shader || GL_NV_vertex_program3
#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB              0x8B4C
#endif

#if GL_ARB_vertex_shader
#define GL_VERTEX_SHADER_ARB                               0x8B31
#define GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB               0x8B4A
#define GL_MAX_VARYING_FLOATS_ARB                          0x8B4B
#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB            0x8B4D
#define GL_OBJECT_ACTIVE_ATTRIBUTES_ARB                    0x8B89
#define GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB          0x8B8A
#endif

#if GL_ARB_fragment_shader
#define GL_FRAGMENT_SHADER_ARB                             0x8B30
#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB             0x8B49
#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB             0x8B8B
#endif

#if GL_ARB_vertex_buffer_object
#define GL_ARRAY_BUFFER_ARB                                0x8892
#define GL_ELEMENT_ARRAY_BUFFER_ARB                        0x8893
#define GL_ARRAY_BUFFER_BINDING_ARB                        0x8894
#define GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB                0x8895
#define GL_VERTEX_ARRAY_BUFFER_BINDING_ARB                 0x8896
#define GL_NORMAL_ARRAY_BUFFER_BINDING_ARB                 0x8897
#define GL_COLOR_ARRAY_BUFFER_BINDING_ARB                  0x8898
#define GL_INDEX_ARRAY_BUFFER_BINDING_ARB                  0x8899
#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB          0x889A
#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB              0x889B
#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB        0x889C
#define GL_FOG_COORD_ARRAY_BUFFER_BINDING_ARB              0x889D
#define GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB                 0x889E
#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB          0x889F
#define GL_STREAM_DRAW_ARB                                 0x88E0
#define GL_STREAM_READ_ARB                                 0x88E1
#define GL_STREAM_COPY_ARB                                 0x88E2
#define GL_STATIC_DRAW_ARB                                 0x88E4
#define GL_STATIC_READ_ARB                                 0x88E5
#define GL_STATIC_COPY_ARB                                 0x88E6
#define GL_DYNAMIC_DRAW_ARB                                0x88E8
#define GL_DYNAMIC_READ_ARB                                0x88E9
#define GL_DYNAMIC_COPY_ARB                                0x88EA
#define GL_READ_ONLY_ARB                                   0x88B8
#define GL_WRITE_ONLY_ARB                                  0x88B9
#define GL_READ_WRITE_ARB                                  0x88BA
#define GL_BUFFER_SIZE_ARB                                 0x8764
#define GL_BUFFER_USAGE_ARB                                0x8765
#define GL_BUFFER_ACCESS_ARB                               0x88BB
#define GL_BUFFER_MAPPED_ARB                               0x88BC
#define GL_BUFFER_MAP_POINTER_ARB                          0x88BD
/* Obsolete */
#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB         0x889D
#endif

#if GL_ARB_point_sprite
#define GL_POINT_SPRITE_ARB                                0x8861
#define GL_COORD_REPLACE_ARB                               0x8862
#endif

#if GL_ARB_texture_rectangle
#define GL_TEXTURE_RECTANGLE_ARB          0x84F5
#define GL_TEXTURE_BINDING_RECTANGLE_ARB  0x84F6
#define GL_PROXY_TEXTURE_RECTANGLE_ARB    0x84F7
#define GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB 0x84F8
#endif

#if GL_ARB_draw_buffers
#define GL_MAX_DRAW_BUFFERS_ARB           0x8824
#define GL_DRAW_BUFFER0_ARB               0x8825
#define GL_DRAW_BUFFER1_ARB               0x8826
#define GL_DRAW_BUFFER2_ARB               0x8827
#define GL_DRAW_BUFFER3_ARB               0x8828
#define GL_DRAW_BUFFER4_ARB               0x8829
#define GL_DRAW_BUFFER5_ARB               0x882A
#define GL_DRAW_BUFFER6_ARB               0x882B
#define GL_DRAW_BUFFER7_ARB               0x882C
#define GL_DRAW_BUFFER8_ARB               0x882D
#define GL_DRAW_BUFFER9_ARB               0x882E
#define GL_DRAW_BUFFER10_ARB              0x882F
#define GL_DRAW_BUFFER11_ARB              0x8830
#define GL_DRAW_BUFFER12_ARB              0x8831
#define GL_DRAW_BUFFER13_ARB              0x8832
#define GL_DRAW_BUFFER14_ARB              0x8833
#define GL_DRAW_BUFFER15_ARB              0x8834
#endif

#if GL_ARB_pixel_buffer_object
#define GL_PIXEL_PACK_BUFFER_ARB                        0x88EB
#define GL_PIXEL_UNPACK_BUFFER_ARB                      0x88EC
#define GL_PIXEL_PACK_BUFFER_BINDING_ARB                0x88ED
#define GL_PIXEL_UNPACK_BUFFER_BINDING_ARB              0x88EF
#endif

#if GL_EXT_polygon_offset
#define GL_POLYGON_OFFSET_EXT             0x8037
#define GL_POLYGON_OFFSET_FACTOR_EXT      0x8038
#define GL_POLYGON_OFFSET_BIAS_EXT        0x8039
#endif

#if GL_EXT_texture
#define GL_ALPHA4_EXT                     0x803B
#define GL_ALPHA8_EXT                     0x803C
#define GL_ALPHA12_EXT                    0x803D
#define GL_ALPHA16_EXT                    0x803E
#define GL_LUMINANCE4_EXT                 0x803F
#define GL_LUMINANCE8_EXT                 0x8040
#define GL_LUMINANCE12_EXT                0x8041
#define GL_LUMINANCE16_EXT                0x8042
#define GL_LUMINANCE4_ALPHA4_EXT          0x8043
#define GL_LUMINANCE6_ALPHA2_EXT          0x8044
#define GL_LUMINANCE8_ALPHA8_EXT          0x8045
#define GL_LUMINANCE12_ALPHA4_EXT         0x8046
#define GL_LUMINANCE12_ALPHA12_EXT        0x8047
#define GL_LUMINANCE16_ALPHA16_EXT        0x8048
#define GL_INTENSITY_EXT                  0x8049
#define GL_INTENSITY4_EXT                 0x804A
#define GL_INTENSITY8_EXT                 0x804B
#define GL_INTENSITY12_EXT                0x804C
#define GL_INTENSITY16_EXT                0x804D
#define GL_RGB2_EXT                       0x804E
#define GL_RGB4_EXT                       0x804F
#define GL_RGB5_EXT                       0x8050
#define GL_RGB8_EXT                       0x8051
#define GL_RGB10_EXT                      0x8052
#define GL_RGB12_EXT                      0x8053
#define GL_RGB16_EXT                      0x8054
#define GL_RGBA2_EXT                      0x8055
#define GL_RGBA4_EXT                      0x8056
#define GL_RGB5_A1_EXT                    0x8057
#define GL_RGBA8_EXT                      0x8058
#define GL_RGB10_A2_EXT                   0x8059
#define GL_RGBA12_EXT                     0x805A
#define GL_RGBA16_EXT                     0x805B
#define GL_TEXTURE_RED_SIZE_EXT           0x805C
#define GL_TEXTURE_GREEN_SIZE_EXT         0x805D
#define GL_TEXTURE_BLUE_SIZE_EXT          0x805E
#define GL_TEXTURE_ALPHA_SIZE_EXT         0x805F
#define GL_TEXTURE_LUMINANCE_SIZE_EXT     0x8060
#define GL_TEXTURE_INTENSITY_SIZE_EXT     0x8061
#define GL_REPLACE_EXT                    0x8062
#define GL_PROXY_TEXTURE_1D_EXT           0x8063
#define GL_PROXY_TEXTURE_2D_EXT           0x8064
#define GL_TEXTURE_TOO_LARGE_EXT          0x8065
#endif

#if GL_EXT_texture3D
#define GL_PACK_SKIP_IMAGES_EXT           0x806B
#define GL_PACK_IMAGE_HEIGHT_EXT          0x806C
#define GL_UNPACK_SKIP_IMAGES_EXT         0x806D
#define GL_UNPACK_IMAGE_HEIGHT_EXT        0x806E
#define GL_TEXTURE_3D_EXT                 0x806F
#define GL_PROXY_TEXTURE_3D_EXT           0x8070
#define GL_TEXTURE_DEPTH_EXT              0x8071
#define GL_TEXTURE_WRAP_R_EXT             0x8072
#define GL_MAX_3D_TEXTURE_SIZE_EXT        0x8073
#endif

#if GL_EXT_histogram
#define GL_HISTOGRAM_EXT                  0x8024
#define GL_PROXY_HISTOGRAM_EXT            0x8025
#define GL_HISTOGRAM_WIDTH_EXT            0x8026
#define GL_HISTOGRAM_FORMAT_EXT           0x8027
#define GL_HISTOGRAM_RED_SIZE_EXT         0x8028
#define GL_HISTOGRAM_GREEN_SIZE_EXT       0x8029
#define GL_HISTOGRAM_BLUE_SIZE_EXT        0x802A
#define GL_HISTOGRAM_ALPHA_SIZE_EXT       0x802B
#define GL_HISTOGRAM_LUMINANCE_SIZE_EXT   0x802C
#define GL_HISTOGRAM_SINK_EXT             0x802D
#define GL_MINMAX_EXT                     0x802E
#define GL_MINMAX_FORMAT_EXT              0x802F
#define GL_MINMAX_SINK_EXT                0x8030
#define GL_TABLE_TOO_LARGE_EXT            0x8031
#endif

#if GL_EXT_convolution
#define GL_CONVOLUTION_1D_EXT             0x8010
#define GL_CONVOLUTION_2D_EXT             0x8011
#define GL_SEPARABLE_2D_EXT               0x8012
#define GL_CONVOLUTION_BORDER_MODE_EXT    0x8013
#define GL_CONVOLUTION_FILTER_SCALE_EXT   0x8014
#define GL_CONVOLUTION_FILTER_BIAS_EXT    0x8015
#define GL_REDUCE_EXT                     0x8016
#define GL_CONVOLUTION_FORMAT_EXT         0x8017
#define GL_CONVOLUTION_WIDTH_EXT          0x8018
#define GL_CONVOLUTION_HEIGHT_EXT         0x8019
#define GL_MAX_CONVOLUTION_WIDTH_EXT      0x801A
#define GL_MAX_CONVOLUTION_HEIGHT_EXT     0x801B
#define GL_POST_CONVOLUTION_RED_SCALE_EXT 0x801C
#define GL_POST_CONVOLUTION_GREEN_SCALE_EXT 0x801D
#define GL_POST_CONVOLUTION_BLUE_SCALE_EXT 0x801E
#define GL_POST_CONVOLUTION_ALPHA_SCALE_EXT 0x801F
#define GL_POST_CONVOLUTION_RED_BIAS_EXT  0x8020
#define GL_POST_CONVOLUTION_GREEN_BIAS_EXT 0x8021
#define GL_POST_CONVOLUTION_BLUE_BIAS_EXT 0x8022
#define GL_POST_CONVOLUTION_ALPHA_BIAS_EXT 0x8023
#endif

#if GL_EXT_cmyka
#define GL_CMYK_EXT                       0x800C
#define GL_CMYKA_EXT                      0x800D
#define GL_PACK_CMYK_HINT_EXT             0x800E
#define GL_UNPACK_CMYK_HINT_EXT           0x800F
#endif

#if GL_EXT_texture_object
#define GL_TEXTURE_PRIORITY_EXT           0x8066
#define GL_TEXTURE_RESIDENT_EXT           0x8067
#define GL_TEXTURE_1D_BINDING_EXT         0x8068
#define GL_TEXTURE_2D_BINDING_EXT         0x8069
#define GL_TEXTURE_3D_BINDING_EXT         0x806A
#endif

#if GL_EXT_packed_pixels
#define GL_UNSIGNED_BYTE_3_3_2_EXT        0x8032
#define GL_UNSIGNED_SHORT_4_4_4_4_EXT     0x8033
#define GL_UNSIGNED_SHORT_5_5_5_1_EXT     0x8034
#define GL_UNSIGNED_INT_8_8_8_8_EXT       0x8035
#define GL_UNSIGNED_INT_10_10_10_2_EXT    0x8036
#endif

#if GL_EXT_vertex_array
#define GL_VERTEX_ARRAY_EXT               0x8074
#define GL_NORMAL_ARRAY_EXT               0x8075
#define GL_COLOR_ARRAY_EXT                0x8076
#define GL_INDEX_ARRAY_EXT                0x8077
#define GL_TEXTURE_COORD_ARRAY_EXT        0x8078
#define GL_EDGE_FLAG_ARRAY_EXT            0x8079
#define GL_VERTEX_ARRAY_SIZE_EXT          0x807A
#define GL_VERTEX_ARRAY_TYPE_EXT          0x807B
#define GL_VERTEX_ARRAY_STRIDE_EXT        0x807C
#define GL_VERTEX_ARRAY_COUNT_EXT         0x807D
#define GL_NORMAL_ARRAY_TYPE_EXT          0x807E
#define GL_NORMAL_ARRAY_STRIDE_EXT        0x807F
#define GL_NORMAL_ARRAY_COUNT_EXT         0x8080
#define GL_COLOR_ARRAY_SIZE_EXT           0x8081
#define GL_COLOR_ARRAY_TYPE_EXT           0x8082
#define GL_COLOR_ARRAY_STRIDE_EXT         0x8083
#define GL_COLOR_ARRAY_COUNT_EXT          0x8084
#define GL_INDEX_ARRAY_TYPE_EXT           0x8085
#define GL_INDEX_ARRAY_STRIDE_EXT         0x8086
#define GL_INDEX_ARRAY_COUNT_EXT          0x8087
#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT   0x8088
#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT   0x8089
#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT 0x808A
#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT  0x808B
#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT     0x808C
#define GL_EDGE_FLAG_ARRAY_COUNT_EXT      0x808D
#define GL_VERTEX_ARRAY_POINTER_EXT       0x808E
#define GL_NORMAL_ARRAY_POINTER_EXT       0x808F
#define GL_COLOR_ARRAY_POINTER_EXT        0x8090
#define GL_INDEX_ARRAY_POINTER_EXT        0x8091
#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT 0x8092
#define GL_EDGE_FLAG_ARRAY_POINTER_EXT    0x8093
#endif

#if GL_EXT_index_material
#define GL_INDEX_MATERIAL_EXT             0x81B8
#define GL_INDEX_MATERIAL_PARAMETER_EXT   0x81B9
#define GL_INDEX_MATERIAL_FACE_EXT        0x81BA
#endif

#if GL_EXT_index_func
#define GL_INDEX_TEST_EXT                 0x81B5
#define GL_INDEX_TEST_FUNC_EXT            0x81B6
#define GL_INDEX_TEST_REF_EXT             0x81B7
#endif

#if GL_EXT_index_array_formats
#define GL_IUI_V2F_EXT                    0x81AD
#define GL_IUI_V3F_EXT                    0x81AE
#define GL_IUI_N3F_V2F_EXT                0x81AF
#define GL_IUI_N3F_V3F_EXT                0x81B0
#define GL_T2F_IUI_V2F_EXT                0x81B1
#define GL_T2F_IUI_V3F_EXT                0x81B2
#define GL_T2F_IUI_N3F_V2F_EXT            0x81B3
#define GL_T2F_IUI_N3F_V3F_EXT            0x81B4
#endif

#if GL_EXT_cull_vertex
#define GL_CULL_VERTEX_EXT                0x81AA
#define GL_CULL_VERTEX_EYE_POSITION_EXT   0x81AB
#define GL_CULL_VERTEX_OBJECT_POSITION_EXT 0x81AC
#endif

#if GL_EXT_light_texture
#define GL_FRAGMENT_MATERIAL_EXT          0x8349
#define GL_FRAGMENT_NORMAL_EXT            0x834A
#define GL_FRAGMENT_COLOR_EXT             0x834C
#define GL_ATTENUATION_EXT                0x834D
#define GL_SHADOW_ATTENUATION_EXT         0x834E
#define GL_TEXTURE_APPLICATION_MODE_EXT   0x834F
#define GL_TEXTURE_LIGHT_EXT              0x8350
#define GL_TEXTURE_MATERIAL_FACE_EXT      0x8351
#define GL_TEXTURE_MATERIAL_PARAMETER_EXT 0x8352
/* reuse GL_FRAGMENT_DEPTH_EXT */
#endif

#if GL_EXT_pixel_transform
#define GL_PIXEL_TRANSFORM_2D_EXT         0x8330
#define GL_PIXEL_MAG_FILTER_EXT           0x8331
#define GL_PIXEL_MIN_FILTER_EXT           0x8332
#define GL_PIXEL_CUBIC_WEIGHT_EXT         0x8333
#define GL_CUBIC_EXT                      0x8334
#define GL_AVERAGE_EXT                    0x8335
#define GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT 0x8336
#define GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT 0x8337
#define GL_PIXEL_TRANSFORM_2D_MATRIX_EXT  0x8338
#endif

#if GL_EXT_separate_specular_color
#define GL_LIGHT_MODEL_COLOR_CONTROL_EXT  0x81F8
#define GL_SINGLE_COLOR_EXT               0x81F9
#define GL_SEPARATE_SPECULAR_COLOR_EXT    0x81FA
#endif

#if GL_EXT_texture_perturb_normal
#define GL_PERTURB_EXT                    0x85AE
#define GL_TEXTURE_NORMAL_EXT             0x85AF
#endif

#if GL_EXT_coordinate_frame
#define GL_TANGENT_ARRAY_EXT              0x8439
#define GL_BINORMAL_ARRAY_EXT             0x843A
#define GL_CURRENT_TANGENT_EXT            0x843B
#define GL_CURRENT_BINORMAL_EXT           0x843C
#define GL_TANGENT_ARRAY_TYPE_EXT         0x843E
#define GL_TANGENT_ARRAY_STRIDE_EXT       0x843F
#define GL_BINORMAL_ARRAY_TYPE_EXT        0x8440
#define GL_BINORMAL_ARRAY_STRIDE_EXT      0x8441
#define GL_TANGENT_ARRAY_POINTER_EXT      0x8442
#define GL_BINORMAL_ARRAY_POINTER_EXT     0x8443
#define GL_MAP1_TANGENT_EXT               0x8444
#define GL_MAP2_TANGENT_EXT               0x8445
#define GL_MAP1_BINORMAL_EXT              0x8446
#define GL_MAP2_BINORMAL_EXT              0x8447
#endif

#if GL_EXT_texture_env_combine
#define GL_COMBINE_EXT                    0x8570
#define GL_COMBINE_RGB_EXT                0x8571
#define GL_COMBINE_ALPHA_EXT              0x8572
#define GL_RGB_SCALE_EXT                  0x8573
#define GL_ADD_SIGNED_EXT                 0x8574
#define GL_INTERPOLATE_EXT                0x8575
#define GL_CONSTANT_EXT                   0x8576
#define GL_PRIMARY_COLOR_EXT              0x8577
#define GL_PREVIOUS_EXT                   0x8578
#define GL_SOURCE0_RGB_EXT                0x8580
#define GL_SOURCE1_RGB_EXT                0x8581
#define GL_SOURCE2_RGB_EXT                0x8582
#define GL_SOURCE3_RGB_EXT                0x8583
#define GL_SOURCE4_RGB_EXT                0x8584
#define GL_SOURCE5_RGB_EXT                0x8585
#define GL_SOURCE6_RGB_EXT                0x8586
#define GL_SOURCE7_RGB_EXT                0x8587
#define GL_SOURCE0_ALPHA_EXT              0x8588
#define GL_SOURCE1_ALPHA_EXT              0x8589
#define GL_SOURCE2_ALPHA_EXT              0x858A
#define GL_SOURCE3_ALPHA_EXT              0x858B
#define GL_SOURCE4_ALPHA_EXT              0x858C
#define GL_SOURCE5_ALPHA_EXT              0x858D
#define GL_SOURCE6_ALPHA_EXT              0x858E
#define GL_SOURCE7_ALPHA_EXT              0x858F
#define GL_OPERAND0_RGB_EXT               0x8590
#define GL_OPERAND1_RGB_EXT               0x8591
#define GL_OPERAND2_RGB_EXT               0x8592
#define GL_OPERAND3_RGB_EXT               0x8593
#define GL_OPERAND4_RGB_EXT               0x8594
#define GL_OPERAND5_RGB_EXT               0x8595
#define GL_OPERAND6_RGB_EXT               0x8596
#define GL_OPERAND7_RGB_EXT               0x8597
#define GL_OPERAND0_ALPHA_EXT             0x8598
#define GL_OPERAND1_ALPHA_EXT             0x8599
#define GL_OPERAND2_ALPHA_EXT             0x859A
#define GL_OPERAND3_ALPHA_EXT             0x859B
#define GL_OPERAND4_ALPHA_EXT             0x859C
#define GL_OPERAND5_ALPHA_EXT             0x859D
#define GL_OPERAND6_ALPHA_EXT             0x859E
#define GL_OPERAND7_ALPHA_EXT             0x859F
#endif

#if GL_EXT_422_pixels
#define GL_422_EXT                        0x80CC
#define GL_422_REV_EXT                    0x80CD
#define GL_422_AVERAGE_EXT                0x80CE
#define GL_422_REV_AVERAGE_EXT            0x80CF
#endif

#if GL_EXT_texture_cube_map
#define GL_NORMAL_MAP_EXT                 0x8511
#define GL_REFLECTION_MAP_EXT             0x8512
#define GL_TEXTURE_CUBE_MAP_EXT           0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP_EXT   0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT 0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT 0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT 0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT 0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT 0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT 0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP_EXT     0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT  0x851C
#endif

#if GL_EXT_vertex_weighting
#define GL_MODELVIEW0_STACK_DEPTH_EXT     GL_MODELVIEW_STACK_DEPTH
#define GL_MODELVIEW1_STACK_DEPTH_EXT     0x8502
#define GL_MODELVIEW0_MATRIX_EXT          GL_MODELVIEW_MATRIX
#define GL_MODELVIEW_MATRIX1_EXT          0x8506
#define GL_VERTEX_WEIGHTING_EXT           0x8509
#define GL_MODELVIEW0_EXT                 GL_MODELVIEW
#define GL_MODELVIEW1_EXT                 0x850A
#define GL_CURRENT_VERTEX_WEIGHT_EXT      0x850B
#define GL_VERTEX_WEIGHT_ARRAY_EXT        0x850C
#define GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT   0x850D
#define GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT   0x850E
#define GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT 0x850F
#define GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT 0x8510
#endif

#if GL_EXT_vertex_shader
#define GL_VERTEX_SHADER_EXT              0x8780
#define GL_VARIANT_VALUE_EXT              0x87E4
#define GL_VARIANT_DATATYPE_EXT           0x87E5
#define GL_VARIANT_ARRAY_STRIDE_EXT       0x87E6
#define GL_VARIANT_ARRAY_TYPE_EXT         0x87E7
#define GL_VARIANT_ARRAY_EXT              0x87E8
#define GL_VARIANT_ARRAY_POINTER_EXT      0x87E9
#define GL_INVARIANT_VALUE_EXT            0x87EA
#define GL_INVARIANT_DATATYPE_EXT         0x87EB
#define GL_LOCAL_CONSTANT_VALUE_EXT       0x87EC
#define GL_LOCAL_CONSTANT_DATATYPE_EXT    0x87Ed
#define GL_OP_INDEX_EXT                   0x8782
#define GL_OP_NEGATE_EXT                  0x8783
#define GL_OP_DOT3_EXT                    0x8784
#define GL_OP_DOT4_EXT                    0x8785
#define GL_OP_MUL_EXT                     0x8786
#define GL_OP_ADD_EXT                     0x8787
#define GL_OP_MADD_EXT                    0x8788
#define GL_OP_FRAC_EXT                    0x8789
#define GL_OP_MAX_EXT                     0x878A
#define GL_OP_MIN_EXT                     0x878B
#define GL_OP_SET_GE_EXT                  0x878C
#define GL_OP_SET_LT_EXT                  0x878D
#define GL_OP_CLAMP_EXT                   0x878E
#define GL_OP_FLOOR_EXT                   0x878F
#define GL_OP_ROUND_EXT                   0x8790
#define GL_OP_EXP_BASE_2_EXT              0x8791
#define GL_OP_LOG_BASE_2_EXT              0x8792
#define GL_OP_POWER_EXT                   0x8793
#define GL_OP_RECIP_EXT                   0x8794
#define GL_OP_RECIP_SQRT_EXT              0x8795
#define GL_OP_SUB_EXT                     0x8796
#define GL_OP_CROSS_PRODUCT_EXT           0x8797
#define GL_OP_MULTIPLY_MATRIX_EXT         0x8798
#define GL_OP_MOV_EXT                     0x8799
#define GL_OUTPUT_VERTEX_EXT              0x879A
#define GL_OUTPUT_COLOR0_EXT              0x879B
#define GL_OUTPUT_COLOR1_EXT              0x879C
#define GL_OUTPUT_TEXTURE_COORD0_EXT      0x879D
#define GL_OUTPUT_TEXTURE_COORD1_EXT      0x879E
#define GL_OUTPUT_TEXTURE_COORD2_EXT      0x879F
#define GL_OUTPUT_TEXTURE_COORD3_EXT      0x87A0
#define GL_OUTPUT_TEXTURE_COORD4_EXT      0x87A1
#define GL_OUTPUT_TEXTURE_COORD5_EXT      0x87A2
#define GL_OUTPUT_TEXTURE_COORD6_EXT      0x87A3
#define GL_OUTPUT_TEXTURE_COORD7_EXT      0x87A4
#define GL_OUTPUT_TEXTURE_COORD8_EXT      0x87A5
#define GL_OUTPUT_TEXTURE_COORD9_EXT      0x87A6
#define GL_OUTPUT_TEXTURE_COORD10_EXT     0x87A7
#define GL_OUTPUT_TEXTURE_COORD11_EXT     0x87A8
#define GL_OUTPUT_TEXTURE_COORD12_EXT     0x87A9
#define GL_OUTPUT_TEXTURE_COORD13_EXT     0x87AA
#define GL_OUTPUT_TEXTURE_COORD14_EXT     0x87AB
#define GL_OUTPUT_TEXTURE_COORD15_EXT     0x87AC
#define GL_OUTPUT_TEXTURE_COORD16_EXT     0x87AD
#define GL_OUTPUT_TEXTURE_COORD17_EXT     0x87AE
#define GL_OUTPUT_TEXTURE_COORD18_EXT     0x87AF
#define GL_OUTPUT_TEXTURE_COORD19_EXT     0x87B0
#define GL_OUTPUT_TEXTURE_COORD20_EXT     0x87B1
#define GL_OUTPUT_TEXTURE_COORD21_EXT     0x87B2
#define GL_OUTPUT_TEXTURE_COORD22_EXT     0x87B3
#define GL_OUTPUT_TEXTURE_COORD23_EXT     0x87B4
#define GL_OUTPUT_TEXTURE_COORD24_EXT     0x87B5
#define GL_OUTPUT_TEXTURE_COORD25_EXT     0x87B6
#define GL_OUTPUT_TEXTURE_COORD26_EXT     0x87B7
#define GL_OUTPUT_TEXTURE_COORD27_EXT     0x87B8
#define GL_OUTPUT_TEXTURE_COORD28_EXT     0x87B9
#define GL_OUTPUT_TEXTURE_COORD29_EXT     0x87BA
#define GL_OUTPUT_TEXTURE_COORD30_EXT     0x87BB
#define GL_OUTPUT_TEXTURE_COORD31_EXT     0x87BC
#define GL_OUTPUT_FOG_EXT                 0x87BD
#define GL_SCALAR_EXT                     0x87BE
#define GL_VECTOR_EXT                     0x87BF
#define GL_MATRIX_EXT                     0x87C0
#define GL_VARIANT_EXT                    0x87C1
#define GL_INVARIANT_EXT                  0x87C2
#define GL_LOCAL_CONSTANT_EXT             0x87C3
#define GL_LOCAL_EXT                      0x87C4
#define GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT              0x87C5
#define GL_MAX_VERTEX_SHADER_VARIANTS_EXT                  0x87C6
#define GL_MAX_VERTEX_SHADER_INVARIANTS_EXT                0x87C7
#define GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT           0x87C8
#define GL_MAX_VERTEX_SHADER_LOCALS_EXT                    0x87C9
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT    0x87CA
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT        0x87CB
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT 0x87CC
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT      0x87CD
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT          0x87CE
#define GL_VERTEX_SHADER_INSTRUCTIONS_EXT                  0x87CF
#define GL_VERTEX_SHADER_VARIANTS_EXT                      0x87D0
#define GL_VERTEX_SHADER_INVARIANTS_EXT                    0x87D1
#define GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT               0x87D2
#define GL_VERTEX_SHADER_LOCALS_EXT                        0x87D3
#define GL_VERTEX_SHADER_BINDING_EXT                       0x8781
#define GL_VERTEX_SHADER_OPTIMIZED_EXT                     0x87D4
#define GL_X_EXT                          0x87D5
#define GL_Y_EXT                          0x87D6
#define GL_Z_EXT                          0x87D7
#define GL_W_EXT                          0x87D8
#define GL_NEGATIVE_X_EXT                 0x87D9
#define GL_NEGATIVE_Y_EXT                 0x87DA
#define GL_NEGATIVE_Z_EXT                 0x87DB
#define GL_NEGATIVE_W_EXT                 0x87DC
#define GL_NEGATIVE_ONE_EXT               0x87DF
#define GL_NORMALIZED_RANGE_EXT           0x87E0
#define GL_FULL_RANGE_EXT                 0x87E1
#define GL_CURRENT_VERTEX_EXT             0x87E2
#define GL_MVP_MATRIX_EXT                 0x87E3
#endif

#if GL_EXT_fragment_shader
#define GL_FRAGMENT_SHADER_EXT            0x8920
#define GL_REG_0_EXT                      0x8921
#define GL_REG_1_EXT                      0x8922
#define GL_REG_2_EXT                      0x8923
#define GL_REG_3_EXT                      0x8924
#define GL_REG_4_EXT                      0x8925
#define GL_REG_5_EXT                      0x8926
#define GL_REG_6_EXT                      0x8927
#define GL_REG_7_EXT                      0x8928
#define GL_REG_8_EXT                      0x8929
#define GL_REG_9_EXT                      0x892A
#define GL_REG_10_EXT                     0x892B
#define GL_REG_11_EXT                     0x892C
#define GL_REG_12_EXT                     0x892D
#define GL_REG_13_EXT                     0x892E
#define GL_REG_14_EXT                     0x892F
#define GL_REG_15_EXT                     0x8930
#define GL_REG_16_EXT                     0x8931
#define GL_REG_17_EXT                     0x8932
#define GL_REG_18_EXT                     0x8933
#define GL_REG_19_EXT                     0x8934
#define GL_REG_20_EXT                     0x8935
#define GL_REG_21_EXT                     0x8936
#define GL_REG_22_EXT                     0x8937
#define GL_REG_23_EXT                     0x8938
#define GL_REG_24_EXT                     0x8939
#define GL_REG_25_EXT                     0x893A
#define GL_REG_26_EXT                     0x893B
#define GL_REG_27_EXT                     0x893C
#define GL_REG_28_EXT                     0x893D
#define GL_REG_29_EXT                     0x893E
#define GL_REG_30_EXT                     0x893F
#define GL_REG_31_EXT                     0x8940
#define GL_CON_0_EXT                      0x8941
#define GL_CON_1_EXT                      0x8942
#define GL_CON_2_EXT                      0x8943
#define GL_CON_3_EXT                      0x8944
#define GL_CON_4_EXT                      0x8945
#define GL_CON_5_EXT                      0x8946
#define GL_CON_6_EXT                      0x8947
#define GL_CON_7_EXT                      0x8948
#define GL_CON_8_EXT                      0x8949
#define GL_CON_9_EXT                      0x894A
#define GL_CON_10_EXT                     0x894B
#define GL_CON_11_EXT                     0x894C
#define GL_CON_12_EXT                     0x894D
#define GL_CON_13_EXT                     0x894E
#define GL_CON_14_EXT                     0x894F
#define GL_CON_15_EXT                     0x8950
#define GL_CON_16_EXT                     0x8951
#define GL_CON_17_EXT                     0x8952
#define GL_CON_18_EXT                     0x8953
#define GL_CON_19_EXT                     0x8954
#define GL_CON_20_EXT                     0x8955
#define GL_CON_21_EXT                     0x8956
#define GL_CON_22_EXT                     0x8957
#define GL_CON_23_EXT                     0x8958
#define GL_CON_24_EXT                     0x8959
#define GL_CON_25_EXT                     0x895A
#define GL_CON_26_EXT                     0x895B
#define GL_CON_27_EXT                     0x895C
#define GL_CON_28_EXT                     0x895D
#define GL_CON_29_EXT                     0x895E
#define GL_CON_30_EXT                     0x895F
#define GL_CON_31_EXT                     0x8960
#define GL_MOV_EXT                        0x8961
#define GL_ADD_EXT                        0x8963
#define GL_MUL_EXT                        0x8964
#define GL_SUB_EXT                        0x8965
#define GL_DOT3_EXT                       0x8966
#define GL_DOT4_EXT                       0x8967
#define GL_MAD_EXT                        0x8968
#define GL_LERP_EXT                       0x8969
#define GL_CND_EXT                        0x896A
#define GL_CND0_EXT                       0x896B
#define GL_DOT2_ADD_EXT                   0x896C
#define GL_SECONDARY_INTERPOLATOR_EXT     0x896D
#define GL_NUM_FRAGMENT_REGISTERS_EXT     0x896E
#define GL_NUM_FRAGMENT_CONSTANTS_EXT     0x896F
#define GL_NUM_PASSES_EXT                 0x8970
#define GL_NUM_INSTRUCTIONS_PER_PASS_EXT  0x8971
#define GL_NUM_INSTRUCTIONS_TOTAL_EXT     0x8972
#define GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_EXT 0x8973
#define GL_NUM_LOOPBACK_COMPONENTS_EXT    0x8974
#define GL_COLOR_ALPHA_PAIRING_EXT        0x8975
#define GL_SWIZZLE_STR_EXT                0x8976
#define GL_SWIZZLE_STQ_EXT                0x8977
#define GL_SWIZZLE_STR_DR_EXT             0x8978
#define GL_SWIZZLE_STQ_DQ_EXT             0x8979
#define GL_SWIZZLE_STRQ_EXT               0x897A
#define GL_SWIZZLE_STRQ_DQ_EXT            0x897B
#define GL_RED_BIT_EXT                    0x00000001
#define GL_GREEN_BIT_EXT                  0x00000002
#define GL_BLUE_BIT_EXT                   0x00000004
#define GL_2X_BIT_EXT                     0x00000001
#define GL_4X_BIT_EXT                     0x00000002
#define GL_8X_BIT_EXT                     0x00000004
#define GL_HALF_BIT_EXT                   0x00000008
#define GL_QUARTER_BIT_EXT                0x00000010
#define GL_EIGHTH_BIT_EXT                 0x00000020
#define GL_SATURATE_BIT_EXT               0x00000040
#define GL_COMP_BIT_EXT                   0x00000002
#define GL_NEGATE_BIT_EXT                 0x00000004
#define GL_BIAS_BIT_EXT                   0x00000008
#endif

#if GL_EXT_multisample
#define GL_MULTISAMPLE_EXT                0x809D
#define GL_SAMPLE_ALPHA_TO_MASK_EXT       0x809E
#define GL_SAMPLE_ALPHA_TO_ONE_EXT        0x809F
#define GL_SAMPLE_MASK_EXT                0x80A0
#define GL_1PASS_EXT                      0x80A1
#define GL_2PASS_0_EXT                    0x80A2
#define GL_2PASS_1_EXT                    0x80A3
#define GL_4PASS_0_EXT                    0x80A4
#define GL_4PASS_1_EXT                    0x80A5
#define GL_4PASS_2_EXT                    0x80A6
#define GL_4PASS_3_EXT                    0x80A7
#define GL_SAMPLE_BUFFERS_EXT             0x80A8
#define GL_SAMPLES_EXT                    0x80A9
#define GL_SAMPLE_MASK_VALUE_EXT          0x80AA
#define GL_SAMPLE_MASK_INVERT_EXT         0x80AB
#define GL_SAMPLE_PATTERN_EXT             0x80AC
#endif

#if GL_EXT_depth_bounds_test
#define GL_DEPTH_BOUNDS_TEST_EXT          0x8890
#define GL_DEPTH_BOUNDS_EXT               0x8891
#endif

#if GL_EXT_blend_equation_separate
#define GL_BLEND_EQUATION_RGB_EXT         0x8009
#define GL_BLEND_EQUATION_ALPHA_EXT       0x883D
#endif

#if GL_EXT_texture_mirror_clamp
#define GL_MIRROR_CLAMP_EXT               0x8742
#define GL_MIRROR_CLAMP_TO_EDGE_EXT       0x8743
#define GL_MIRROR_CLAMP_TO_BORDER_EXT     0x8912
#endif

#if GL_EXT_framebuffer_object
#define GL_FRAMEBUFFER_EXT                 0x8D40
#define GL_RENDERBUFFER_EXT                0x8D41
#define GL_STENCIL_INDEX1_EXT              0x8D46
#define GL_STENCIL_INDEX4_EXT              0x8D47
#define GL_STENCIL_INDEX8_EXT              0x8D48
#define GL_STENCIL_INDEX16_EXT             0x8D49
#define GL_RENDERBUFFER_WIDTH_EXT           0x8D42
#define GL_RENDERBUFFER_HEIGHT_EXT          0x8D43
#define GL_RENDERBUFFER_INTERNAL_FORMAT_EXT 0x8D44
#define GL_RENDERBUFFER_RED_SIZE_EXT        0x8D50
#define GL_RENDERBUFFER_GREEN_SIZE_EXT      0x8D51
#define GL_RENDERBUFFER_BLUE_SIZE_EXT       0x8D52
#define GL_RENDERBUFFER_ALPHA_SIZE_EXT      0x8D53
#define GL_RENDERBUFFER_DEPTH_SIZE_EXT      0x8D54
#define GL_RENDERBUFFER_STENCIL_SIZE_EXT    0x8D55
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT           0x8CD0
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT           0x8CD1
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT         0x8CD2
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT 0x8CD3
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT    0x8CD4
#define GL_COLOR_ATTACHMENT0_EXT           0x8CE0
#define GL_COLOR_ATTACHMENT1_EXT           0x8CE1
#define GL_COLOR_ATTACHMENT2_EXT           0x8CE2
#define GL_COLOR_ATTACHMENT3_EXT           0x8CE3
#define GL_COLOR_ATTACHMENT4_EXT           0x8CE4
#define GL_COLOR_ATTACHMENT5_EXT           0x8CE5
#define GL_COLOR_ATTACHMENT6_EXT           0x8CE6
#define GL_COLOR_ATTACHMENT7_EXT           0x8CE7
#define GL_COLOR_ATTACHMENT8_EXT           0x8CE8
#define GL_COLOR_ATTACHMENT9_EXT           0x8CE9
#define GL_COLOR_ATTACHMENT10_EXT          0x8CEA
#define GL_COLOR_ATTACHMENT11_EXT          0x8CEB
#define GL_COLOR_ATTACHMENT12_EXT          0x8CEC
#define GL_COLOR_ATTACHMENT13_EXT          0x8CED
#define GL_COLOR_ATTACHMENT14_EXT          0x8CEE
#define GL_COLOR_ATTACHMENT15_EXT          0x8CEF
#define GL_DEPTH_ATTACHMENT_EXT            0x8D00
#define GL_STENCIL_ATTACHMENT_EXT          0x8D20
#define GL_FRAMEBUFFER_COMPLETE_EXT                        0x8CD5
#define GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT           0x8CD6
#define GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT   0x8CD7
#define GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT 0x8CD8
#define GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT           0x8CD9
#define GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT              0x8CDA
#define GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT          0x8CDB
#define GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT          0x8CDC
#define GL_FRAMEBUFFER_UNSUPPORTED_EXT                     0x8CDD
#define GL_FRAMEBUFFER_BINDING_EXT         0x8CA6
#define GL_RENDERBUFFER_BINDING_EXT        0x8CA7
#define GL_MAX_COLOR_ATTACHMENTS_EXT       0x8CDF
#define GL_MAX_RENDERBUFFER_SIZE_EXT       0x84E8
#define GL_INVALID_FRAMEBUFFER_OPERATION_EXT 0x0506
#endif

#if GL_APPLE_vertex_array_range
#define GL_STORAGE_CLIENT_APPLE                 0x85B4
#endif

#if GL_APPLE_fence
#define GL_BUFFER_OBJECT_APPLE            0x85B3
#endif

#if GL_APPLE_texture_range
#define GL_TEXTURE_MINIMIZE_STORAGE_APPLE  0x85B6
#endif

#if GL_APPLE_float_pixels
#define GL_HALF_APPLE                      0x140B
#endif

#if GL_APPLE_pixel_buffer
#define GL_MIN_PBUFFER_VIEWPORT_DIMS_APPLE 0x8A10
#endif

#if GL_APPLE_vertex_program_evaluators
#define GL_VERTEX_ATTRIB_MAP1_APPLE                      0x8A00
#define GL_VERTEX_ATTRIB_MAP2_APPLE                      0x8A01
#define GL_VERTEX_ATTRIB_MAP1_SIZE_APPLE                 0x8A02
#define GL_VERTEX_ATTRIB_MAP1_COEFF_APPLE                0x8A03
#define GL_VERTEX_ATTRIB_MAP1_ORDER_APPLE                0x8A04
#define GL_VERTEX_ATTRIB_MAP1_DOMAIN_APPLE               0x8A05
#define GL_VERTEX_ATTRIB_MAP2_SIZE_APPLE                 0x8A06
#define GL_VERTEX_ATTRIB_MAP2_COEFF_APPLE                0x8A07
#define GL_VERTEX_ATTRIB_MAP2_ORDER_APPLE                0x8A08
#define GL_VERTEX_ATTRIB_MAP2_DOMAIN_APPLE               0x8A09
#endif

#if GL_ATI_separate_stencil
#define GL_STENCIL_BACK_FUNC_ATI            0x8800
#define GL_STENCIL_BACK_FAIL_ATI            0x8801
#define GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI 0x8802
#define GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI 0x8803
#endif

#if GL_ATI_array_rev_comps_in_4_bytes
#define GL_ARRAY_REV_COMPS_IN_4_BYTES_ATI 0x897C
#endif

#if GL_ATI_texture_compression_3dc
#define GL_COMPRESSED_LUMINANCE_ALPHA_3DC_ATI           0x8837
#endif

#if GL_ATI_texture_float
#define GL_RGBA_FLOAT32_ATI                             0x8814
#define GL_RGB_FLOAT32_ATI                              0x8815
#define GL_ALPHA_FLOAT32_ATI                            0x8816
#define GL_INTENSITY_FLOAT32_ATI                        0x8817
#define GL_LUMINANCE_FLOAT32_ATI                        0x8818
#define GL_LUMINANCE_ALPHA_FLOAT32_ATI                  0x8819
#define GL_RGBA_FLOAT16_ATI                             0x881A
#define GL_RGB_FLOAT16_ATI                              0x881B
#define GL_ALPHA_FLOAT16_ATI                            0x881C
#define GL_INTENSITY_FLOAT16_ATI                        0x881D
#define GL_LUMINANCE_FLOAT16_ATI                        0x881E
#define GL_LUMINANCE_ALPHA_FLOAT16_ATI                  0x881F
#endif

#if GL_HP_image_transform
#define GL_IMAGE_SCALE_X_HP               0x8155
#define GL_IMAGE_SCALE_Y_HP               0x8156
#define GL_IMAGE_TRANSLATE_X_HP           0x8157
#define GL_IMAGE_TRANSLATE_Y_HP           0x8158
#define GL_IMAGE_ROTATE_ANGLE_HP          0x8159
#define GL_IMAGE_ROTATE_ORIGIN_X_HP       0x815A
#define GL_IMAGE_ROTATE_ORIGIN_Y_HP       0x815B
#define GL_IMAGE_MAG_FILTER_HP            0x815C
#define GL_IMAGE_MIN_FILTER_HP            0x815D
#define GL_IMAGE_CUBIC_WEIGHT_HP          0x815E
#define GL_CUBIC_HP                       0x815F
#define GL_AVERAGE_HP                     0x8160
#define GL_IMAGE_TRANSFORM_2D_HP          0x8161
#define GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP 0x8162
#define GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP 0x8163
#endif

#if GL_HP_convolution_border_modes
#define GL_IGNORE_BORDER_HP               0x8150
#define GL_CONSTANT_BORDER_HP             0x8151
#define GL_REPLICATE_BORDER_HP            0x8153
#define GL_CONVOLUTION_BORDER_COLOR_HP    0x8154
#endif

#if GL_HP_texture_lighting
#define GL_TEXTURE_LIGHTING_MODE_HP       0x8167
#define GL_TEXTURE_POST_SPECULAR_HP       0x8168
#define GL_TEXTURE_PRE_SPECULAR_HP        0x8169
#endif

#if GL_HP_occlusion_test
#define GL_OCCLUSION_TEST_HP              0x8165
#define GL_OCCLUSION_TEST_RESULT_HP       0x8166
#endif

#if GL_IBM_cull_vertex
#define GL_CULL_VERTEX_IBM                103050
#endif

#if GL_IBM_vertex_array_lists
#define GL_VERTEX_ARRAY_LIST_IBM          103070
#define GL_NORMAL_ARRAY_LIST_IBM          103071
#define GL_COLOR_ARRAY_LIST_IBM           103072
#define GL_INDEX_ARRAY_LIST_IBM           103073
#define GL_TEXTURE_COORD_ARRAY_LIST_IBM   103074
#define GL_EDGE_FLAG_ARRAY_LIST_IBM       103075
#define GL_FOG_COORDINATE_ARRAY_LIST_IBM  103076
#define GL_SECONDARY_COLOR_ARRAY_LIST_IBM 103077
#define GL_VERTEX_ARRAY_LIST_STRIDE_IBM   103080
#define GL_NORMAL_ARRAY_LIST_STRIDE_IBM   103081
#define GL_COLOR_ARRAY_LIST_STRIDE_IBM    103082
#define GL_INDEX_ARRAY_LIST_STRIDE_IBM    103083
#define GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM 103084
#define GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM 103085
#define GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM 103086
#define GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM 103087
#endif

#if GL_INGR_color_clamp
#define GL_RED_MIN_CLAMP_INGR             0x8560
#define GL_GREEN_MIN_CLAMP_INGR           0x8561
#define GL_BLUE_MIN_CLAMP_INGR            0x8562
#define GL_ALPHA_MIN_CLAMP_INGR           0x8563
#define GL_RED_MAX_CLAMP_INGR             0x8564
#define GL_GREEN_MAX_CLAMP_INGR           0x8565
#define GL_BLUE_MAX_CLAMP_INGR            0x8566
#define GL_ALPHA_MAX_CLAMP_INGR           0x8567
#endif

#if GL_INGR_interlace_read
#define GL_INTERLACE_READ_INGR            0x8568
#endif

#if GL_INTEL_parallel_arrays
#define GL_PARALLEL_ARRAYS_INTEL          0x83F4
#define GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL 0x83F5
#define GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL 0x83F6
#define GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL 0x83F7
#define GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL 0x83F8
#endif

#if GL_NV_vertex_array_range
#define GL_VERTEX_ARRAY_RANGE_NV          0x851D
#define GL_VERTEX_ARRAY_RANGE_LENGTH_NV   0x851E
#define GL_VERTEX_ARRAY_RANGE_VALID_NV    0x851F
#define GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV 0x8520
#define GL_VERTEX_ARRAY_RANGE_POINTER_NV  0x8521
#endif

#if GL_NV_vertex_array_range2
#define GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV 0x8533
#endif

#if GL_NV_texgen_emboss
#define GL_EMBOSS_LIGHT_NV                0x855D
#define GL_EMBOSS_CONSTANT_NV             0x855E
#define GL_EMBOSS_MAP_NV                  0x855F
#endif

#if GL_NV_vertex_program
#define GL_VERTEX_PROGRAM_NV              0x8620
#define GL_VERTEX_STATE_PROGRAM_NV        0x8621
#define GL_ATTRIB_ARRAY_SIZE_NV           0x8623
#define GL_ATTRIB_ARRAY_STRIDE_NV         0x8624
#define GL_ATTRIB_ARRAY_TYPE_NV           0x8625
#define GL_CURRENT_ATTRIB_NV              0x8626
#define GL_PROGRAM_LENGTH_NV              0x8627
#define GL_PROGRAM_STRING_NV              0x8628
#define GL_MODELVIEW_PROJECTION_NV        0x8629
#define GL_IDENTITY_NV                    0x862A
#define GL_INVERSE_NV                     0x862B
#define GL_TRANSPOSE_NV                   0x862C
#define GL_INVERSE_TRANSPOSE_NV           0x862D
#define GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV 0x862E
#define GL_MAX_TRACK_MATRICES_NV          0x862F
#define GL_MATRIX0_NV                     0x8630
#define GL_MATRIX1_NV                     0x8631
#define GL_MATRIX2_NV                     0x8632
#define GL_MATRIX3_NV                     0x8633
#define GL_MATRIX4_NV                     0x8634
#define GL_MATRIX5_NV                     0x8635
#define GL_MATRIX6_NV                     0x8636
#define GL_MATRIX7_NV                     0x8637
#define GL_CURRENT_MATRIX_STACK_DEPTH_NV  0x8640
#define GL_CURRENT_MATRIX_NV              0x8641
#define GL_VERTEX_PROGRAM_POINT_SIZE_NV   0x8642
#define GL_VERTEX_PROGRAM_TWO_SIDE_NV     0x8643
#define GL_PROGRAM_PARAMETER_NV           0x8644
#define GL_ATTRIB_ARRAY_POINTER_NV        0x8645
#define GL_PROGRAM_TARGET_NV              0x8646
#define GL_PROGRAM_RESIDENT_NV            0x8647
#define GL_TRACK_MATRIX_NV                0x8648
#define GL_TRACK_MATRIX_TRANSFORM_NV      0x8649
#define GL_VERTEX_PROGRAM_BINDING_NV      0x864A
#define GL_PROGRAM_ERROR_POSITION_NV      0x864B
#define GL_VERTEX_ATTRIB_ARRAY0_NV        0x8650
#define GL_VERTEX_ATTRIB_ARRAY1_NV        0x8651
#define GL_VERTEX_ATTRIB_ARRAY2_NV        0x8652
#define GL_VERTEX_ATTRIB_ARRAY3_NV        0x8653
#define GL_VERTEX_ATTRIB_ARRAY4_NV        0x8654
#define GL_VERTEX_ATTRIB_ARRAY5_NV        0x8655
#define GL_VERTEX_ATTRIB_ARRAY6_NV        0x8656
#define GL_VERTEX_ATTRIB_ARRAY7_NV        0x8657
#define GL_VERTEX_ATTRIB_ARRAY8_NV        0x8658
#define GL_VERTEX_ATTRIB_ARRAY9_NV        0x8659
#define GL_VERTEX_ATTRIB_ARRAY10_NV       0x865A
#define GL_VERTEX_ATTRIB_ARRAY11_NV       0x865B
#define GL_VERTEX_ATTRIB_ARRAY12_NV       0x865C
#define GL_VERTEX_ATTRIB_ARRAY13_NV       0x865D
#define GL_VERTEX_ATTRIB_ARRAY14_NV       0x865E
#define GL_VERTEX_ATTRIB_ARRAY15_NV       0x865F
#define GL_MAP1_VERTEX_ATTRIB0_4_NV       0x8660
#define GL_MAP1_VERTEX_ATTRIB1_4_NV       0x8661
#define GL_MAP1_VERTEX_ATTRIB2_4_NV       0x8662
#define GL_MAP1_VERTEX_ATTRIB3_4_NV       0x8663
#define GL_MAP1_VERTEX_ATTRIB4_4_NV       0x8664
#define GL_MAP1_VERTEX_ATTRIB5_4_NV       0x8665
#define GL_MAP1_VERTEX_ATTRIB6_4_NV       0x8666
#define GL_MAP1_VERTEX_ATTRIB7_4_NV       0x8667
#define GL_MAP1_VERTEX_ATTRIB8_4_NV       0x8668
#define GL_MAP1_VERTEX_ATTRIB9_4_NV       0x8669
#define GL_MAP1_VERTEX_ATTRIB10_4_NV      0x866A
#define GL_MAP1_VERTEX_ATTRIB11_4_NV      0x866B
#define GL_MAP1_VERTEX_ATTRIB12_4_NV      0x866C
#define GL_MAP1_VERTEX_ATTRIB13_4_NV      0x866D
#define GL_MAP1_VERTEX_ATTRIB14_4_NV      0x866E
#define GL_MAP1_VERTEX_ATTRIB15_4_NV      0x866F
#define GL_MAP2_VERTEX_ATTRIB0_4_NV       0x8670
#define GL_MAP2_VERTEX_ATTRIB1_4_NV       0x8671
#define GL_MAP2_VERTEX_ATTRIB2_4_NV       0x8672
#define GL_MAP2_VERTEX_ATTRIB3_4_NV       0x8673
#define GL_MAP2_VERTEX_ATTRIB4_4_NV       0x8674
#define GL_MAP2_VERTEX_ATTRIB5_4_NV       0x8675
#define GL_MAP2_VERTEX_ATTRIB6_4_NV       0x8676
#define GL_MAP2_VERTEX_ATTRIB7_4_NV       0x8677
#define GL_MAP2_VERTEX_ATTRIB8_4_NV       0x8678
#define GL_MAP2_VERTEX_ATTRIB9_4_NV       0x8679
#define GL_MAP2_VERTEX_ATTRIB10_4_NV      0x867A
#define GL_MAP2_VERTEX_ATTRIB11_4_NV      0x867B
#define GL_MAP2_VERTEX_ATTRIB12_4_NV      0x867C
#define GL_MAP2_VERTEX_ATTRIB13_4_NV      0x867D
#define GL_MAP2_VERTEX_ATTRIB14_4_NV      0x867E
#define GL_MAP2_VERTEX_ATTRIB15_4_NV      0x867F
#endif

#if GL_NV_fragment_program2 || GL_NV_vertex_program2_option
#define GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV              0x88F4
#define GL_MAX_PROGRAM_CALL_DEPTH_NV                     0x88F5
#endif

#if GL_NV_fragment_program2
#define GL_MAX_PROGRAM_IF_DEPTH_NV                       0x88F6
#define GL_MAX_PROGRAM_LOOP_DEPTH_NV                     0x88F7
#define GL_MAX_PROGRAM_LOOP_COUNT_NV                     0x88F8
#endif

#if GL_PGI_vertex_hints
#define GL_VERTEX_DATA_HINT_PGI           0x1A22A
#define GL_VERTEX_CONSISTENT_HINT_PGI     0x1A22B
#define GL_MATERIAL_SIDE_HINT_PGI         0x1A22C
#define GL_MAX_VERTEX_HINT_PGI            0x1A22D
#define GL_COLOR3_BIT_PGI                 0x00010000
#define GL_COLOR4_BIT_PGI                 0x00020000
#define GL_EDGEFLAG_BIT_PGI               0x00040000
#define GL_INDEX_BIT_PGI                  0x00080000
#define GL_MAT_AMBIENT_BIT_PGI            0x00100000
#define GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI 0x00200000
#define GL_MAT_DIFFUSE_BIT_PGI            0x00400000
#define GL_MAT_EMISSION_BIT_PGI           0x00800000
#define GL_MAT_COLOR_INDEXES_BIT_PGI      0x01000000
#define GL_MAT_SHININESS_BIT_PGI          0x02000000
#define GL_MAT_SPECULAR_BIT_PGI           0x04000000
#define GL_NORMAL_BIT_PGI                 0x08000000
#define GL_TEXCOORD1_BIT_PGI              0x10000000
#define GL_TEXCOORD2_BIT_PGI              0x20000000
#define GL_TEXCOORD3_BIT_PGI              0x40000000
#define GL_TEXCOORD4_BIT_PGI              0x80000000
#define GL_VERTEX23_BIT_PGI               0x00000004
#define GL_VERTEX4_BIT_PGI                0x00000008
#endif

#if GL_PGI_misc_hints
#define GL_PREFER_DOUBLEBUFFER_HINT_PGI   0x1A1F8
#define GL_CONSERVE_MEMORY_HINT_PGI       0x1A1FD
#define GL_RECLAIM_MEMORY_HINT_PGI        0x1A1FE
#define GL_NATIVE_GRAPHICS_HANDLE_PGI     0x1A202
#define GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI 0x1A203
#define GL_NATIVE_GRAPHICS_END_HINT_PGI   0x1A204
#define GL_ALWAYS_FAST_HINT_PGI           0x1A20C
#define GL_ALWAYS_SOFT_HINT_PGI           0x1A20D
#define GL_ALLOW_DRAW_OBJ_HINT_PGI        0x1A20E
#define GL_ALLOW_DRAW_WIN_HINT_PGI        0x1A20F
#define GL_ALLOW_DRAW_FRG_HINT_PGI        0x1A210
#define GL_ALLOW_DRAW_MEM_HINT_PGI        0x1A211
#define GL_STRICT_DEPTHFUNC_HINT_PGI      0x1A216
#define GL_STRICT_LIGHTING_HINT_PGI       0x1A217
#define GL_STRICT_SCISSOR_HINT_PGI        0x1A218
#define GL_FULL_STIPPLE_HINT_PGI          0x1A219
#define GL_CLIP_NEAR_HINT_PGI             0x1A220
#define GL_CLIP_FAR_HINT_PGI              0x1A221
#define GL_WIDE_LINE_HINT_PGI             0x1A222
#define GL_BACK_NORMALS_HINT_PGI          0x1A223
#endif


#if GL_REND_screen_coordinates
#define GL_SCREEN_COORDINATES_REND        0x8490
#define GL_INVERTED_SCREEN_W_REND         0x8491
#endif


#if GL_SGI_color_matrix
#define GL_COLOR_MATRIX_SGI               0x80B1
#define GL_COLOR_MATRIX_STACK_DEPTH_SGI   0x80B2
#define GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI 0x80B3
#define GL_POST_COLOR_MATRIX_RED_SCALE_SGI 0x80B4
#define GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI 0x80B5
#define GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI 0x80B6
#define GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI 0x80B7
#define GL_POST_COLOR_MATRIX_RED_BIAS_SGI 0x80B8
#define GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI 0x80B9
#define GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI 0x80BA
#define GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI 0x80BB
#endif

#if GL_SGI_color_table
#define GL_COLOR_TABLE_SGI                0x80D0
#define GL_POST_CONVOLUTION_COLOR_TABLE_SGI 0x80D1
#define GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI 0x80D2
#define GL_PROXY_COLOR_TABLE_SGI          0x80D3
#define GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI 0x80D4
#define GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI 0x80D5
#define GL_COLOR_TABLE_SCALE_SGI          0x80D6
#define GL_COLOR_TABLE_BIAS_SGI           0x80D7
#define GL_COLOR_TABLE_FORMAT_SGI         0x80D8
#define GL_COLOR_TABLE_WIDTH_SGI          0x80D9
#define GL_COLOR_TABLE_RED_SIZE_SGI       0x80DA
#define GL_COLOR_TABLE_GREEN_SIZE_SGI     0x80DB
#define GL_COLOR_TABLE_BLUE_SIZE_SGI      0x80DC
#define GL_COLOR_TABLE_ALPHA_SIZE_SGI     0x80DD
#define GL_COLOR_TABLE_LUMINANCE_SIZE_SGI 0x80DE
#define GL_COLOR_TABLE_INTENSITY_SIZE_SGI 0x80DF
#endif

#if GL_SGI_texture_color_table
#define GL_TEXTURE_COLOR_TABLE_SGI        0x80BC
#define GL_PROXY_TEXTURE_COLOR_TABLE_SGI  0x80BD
#endif

#if GL_SGI_depth_pass_instrument
#define GL_DEPTH_PASS_INSTRUMENT_SGIX     0x8310
#define GL_DEPTH_PASS_INSTRUMENT_COUNTERS_SGIX 0x8311
#define GL_DEPTH_PASS_INSTRUMENT_MAX_SGIX 0x8312
#endif

#if GL_SGIS_texture_filter4
#define GL_FILTER4_SGIS                   0x8146
#define GL_TEXTURE_FILTER4_SIZE_SGIS      0x8147
#endif

#if GL_SGIS_pixel_texture
#define GL_PIXEL_TEXTURE_SGIS             0x8353
#define GL_PIXEL_FRAGMENT_RGB_SOURCE_SGIS 0x8354
#define GL_PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS 0x8355
#define GL_PIXEL_GROUP_COLOR_SGIS         0x8356
#endif

#if GL_SGIS_texture4D
#define GL_PACK_SKIP_VOLUMES_SGIS         0x8130
#define GL_PACK_IMAGE_DEPTH_SGIS          0x8131
#define GL_UNPACK_SKIP_VOLUMES_SGIS       0x8132
#define GL_UNPACK_IMAGE_DEPTH_SGIS        0x8133
#define GL_TEXTURE_4D_SGIS                0x8134
#define GL_PROXY_TEXTURE_4D_SGIS          0x8135
#define GL_TEXTURE_4DSIZE_SGIS            0x8136
#define GL_TEXTURE_WRAP_Q_SGIS            0x8137
#define GL_MAX_4D_TEXTURE_SIZE_SGIS       0x8138
#define GL_TEXTURE_4D_BINDING_SGIS        0x814F
#endif

#if GL_SGIS_detail_texture
#define GL_DETAIL_TEXTURE_2D_SGIS         0x8095
#define GL_DETAIL_TEXTURE_2D_BINDING_SGIS 0x8096
#define GL_LINEAR_DETAIL_SGIS             0x8097
#define GL_LINEAR_DETAIL_ALPHA_SGIS       0x8098
#define GL_LINEAR_DETAIL_COLOR_SGIS       0x8099
#define GL_DETAIL_TEXTURE_LEVEL_SGIS      0x809A
#define GL_DETAIL_TEXTURE_MODE_SGIS       0x809B
#define GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS 0x809C
#endif

#if GL_SGIS_sharpen_texture
#define GL_LINEAR_SHARPEN_SGIS            0x80AD
#define GL_LINEAR_SHARPEN_ALPHA_SGIS      0x80AE
#define GL_LINEAR_SHARPEN_COLOR_SGIS      0x80AF
#define GL_SHARPEN_TEXTURE_FUNC_POINTS_SGIS 0x80B0
#endif

#if GL_SGIS_multisample
#define GL_MULTISAMPLE_SGIS               0x809D
#define GL_SAMPLE_ALPHA_TO_MASK_SGIS      0x809E
#define GL_SAMPLE_ALPHA_TO_ONE_SGIS       0x809F
#define GL_SAMPLE_MASK_SGIS               0x80A0
#define GL_1PASS_SGIS                     0x80A1
#define GL_2PASS_0_SGIS                   0x80A2
#define GL_2PASS_1_SGIS                   0x80A3
#define GL_4PASS_0_SGIS                   0x80A4
#define GL_4PASS_1_SGIS                   0x80A5
#define GL_4PASS_2_SGIS                   0x80A6
#define GL_4PASS_3_SGIS                   0x80A7
#define GL_SAMPLE_BUFFERS_SGIS            0x80A8
#define GL_SAMPLES_SGIS                   0x80A9
#define GL_SAMPLE_MASK_VALUE_SGIS         0x80AA
#define GL_SAMPLE_MASK_INVERT_SGIS        0x80AB
#define GL_SAMPLE_PATTERN_SGIS            0x80AC
#endif

#if GL_SGIS_texture_border_clamp
#define GL_CLAMP_TO_BORDER_SGIS           0x812D
#endif

#if GL_SGIS_texture_select
#define GL_DUAL_ALPHA4_SGIS               0x8110
#define GL_DUAL_ALPHA8_SGIS               0x8111
#define GL_DUAL_ALPHA12_SGIS              0x8112
#define GL_DUAL_ALPHA16_SGIS              0x8113
#define GL_DUAL_LUMINANCE4_SGIS           0x8114
#define GL_DUAL_LUMINANCE8_SGIS           0x8115
#define GL_DUAL_LUMINANCE12_SGIS          0x8116
#define GL_DUAL_LUMINANCE16_SGIS          0x8117
#define GL_DUAL_INTENSITY4_SGIS           0x8118
#define GL_DUAL_INTENSITY8_SGIS           0x8119
#define GL_DUAL_INTENSITY12_SGIS          0x811A
#define GL_DUAL_INTENSITY16_SGIS          0x811B
#define GL_DUAL_LUMINANCE_ALPHA4_SGIS     0x811C
#define GL_DUAL_LUMINANCE_ALPHA8_SGIS     0x811D
#define GL_QUAD_ALPHA4_SGIS               0x811E
#define GL_QUAD_ALPHA8_SGIS               0x811F
#define GL_QUAD_LUMINANCE4_SGIS           0x8120
#define GL_QUAD_LUMINANCE8_SGIS           0x8121
#define GL_QUAD_INTENSITY4_SGIS           0x8122
#define GL_QUAD_INTENSITY8_SGIS           0x8123
#define GL_DUAL_TEXTURE_SELECT_SGIS       0x8124
#define GL_QUAD_TEXTURE_SELECT_SGIS       0x8125
#endif

#if GL_SGIS_point_parameters
#define GL_POINT_SIZE_MIN_EXT             0x8126
#define GL_POINT_SIZE_MIN_SGIS            0x8126
#define GL_POINT_SIZE_MAX_EXT             0x8127
#define GL_POINT_SIZE_MAX_SGIS            0x8127
#define GL_POINT_FADE_THRESHOLD_SIZE_EXT  0x8128
#define GL_POINT_FADE_THRESHOLD_SIZE_SGIS 0x8128
#define GL_DISTANCE_ATTENUATION_EXT       0x8129
#define GL_DISTANCE_ATTENUATION_SGIS      0x8129
#endif

#if GL_SGIS_fog_function
#define GL_FOG_FUNC_SGIS                  0x812A
#define GL_FOG_FUNC_POINTS_SGIS           0x812B
#define GL_MAX_FOG_FUNC_POINTS_SGIS       0x812C
#endif

#if GL_SGIS_point_line_texgen
#define GL_EYE_DISTANCE_TO_POINT_SGIS     0x81F0
#define GL_OBJECT_DISTANCE_TO_POINT_SGIS  0x81F1
#define GL_EYE_DISTANCE_TO_LINE_SGIS      0x81F2
#define GL_OBJECT_DISTANCE_TO_LINE_SGIS   0x81F3
#define GL_EYE_POINT_SGIS                 0x81F4
#define GL_OBJECT_POINT_SGIS              0x81F5
#define GL_EYE_LINE_SGIS                  0x81F6
#define GL_OBJECT_LINE_SGIS               0x81F7
#endif

#if GL_SGIS_texture_color_mask
#define GL_TEXTURE_COLOR_WRITEMASK_SGIS   0x81EF
#endif

#if GL_SGIX_pixel_texture
#define GL_PIXEL_TEX_GEN_SGIX             0x8139
#define GL_PIXEL_TEX_GEN_MODE_SGIX        0x832B
#endif

#if GL_SGIX_clipmap
#define GL_LINEAR_CLIPMAP_LINEAR_SGIX     0x8170
#define GL_TEXTURE_CLIPMAP_CENTER_SGIX    0x8171
#define GL_TEXTURE_CLIPMAP_FRAME_SGIX     0x8172
#define GL_TEXTURE_CLIPMAP_OFFSET_SGIX    0x8173
#define GL_TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX 0x8174
#define GL_TEXTURE_CLIPMAP_LOD_OFFSET_SGIX 0x8175
#define GL_TEXTURE_CLIPMAP_DEPTH_SGIX     0x8176
#define GL_MAX_CLIPMAP_DEPTH_SGIX         0x8177
#define GL_MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX 0x8178
#define GL_NEAREST_CLIPMAP_NEAREST_SGIX   0x844D
#define GL_NEAREST_CLIPMAP_LINEAR_SGIX    0x844E
#define GL_LINEAR_CLIPMAP_NEAREST_SGIX    0x844F
#endif

#if GL_SGIX_shadow
#define GL_TEXTURE_COMPARE_SGIX           0x819A
#define GL_TEXTURE_COMPARE_OPERATOR_SGIX  0x819B
#define GL_TEXTURE_LEQUAL_R_SGIX          0x819C
#define GL_TEXTURE_GEQUAL_R_SGIX          0x819D
#endif

#if GL_SGIX_interlace
#define GL_INTERLACE_SGIX                 0x8094
#endif

#if GL_SGIX_pixel_tiles
#define GL_PIXEL_TILE_BEST_ALIGNMENT_SGIX 0x813E
#define GL_PIXEL_TILE_CACHE_INCREMENT_SGIX 0x813F
#define GL_PIXEL_TILE_WIDTH_SGIX          0x8140
#define GL_PIXEL_TILE_HEIGHT_SGIX         0x8141
#define GL_PIXEL_TILE_GRID_WIDTH_SGIX     0x8142
#define GL_PIXEL_TILE_GRID_HEIGHT_SGIX    0x8143
#define GL_PIXEL_TILE_GRID_DEPTH_SGIX     0x8144
#define GL_PIXEL_TILE_CACHE_SIZE_SGIX     0x8145
#endif

#if GL_SGIX_sprite
#define GL_SPRITE_SGIX                    0x8148
#define GL_SPRITE_MODE_SGIX               0x8149
#define GL_SPRITE_AXIS_SGIX               0x814A
#define GL_SPRITE_TRANSLATION_SGIX        0x814B
#define GL_SPRITE_AXIAL_SGIX              0x814C
#define GL_SPRITE_OBJECT_ALIGNED_SGIX     0x814D
#define GL_SPRITE_EYE_ALIGNED_SGIX        0x814E
#endif

#if GL_SGIX_texture_multi_buffer
#define GL_TEXTURE_MULTI_BUFFER_HINT_SGIX 0x812E
#endif

#if GL_SGIX_instruments
#define GL_INSTRUMENT_BUFFER_POINTER_SGIX 0x8180
#define GL_INSTRUMENT_MEASUREMENTS_SGIX   0x8181
#endif

#if GL_SGIX_texture_scale_bias
#define GL_POST_TEXTURE_FILTER_BIAS_SGIX  0x8179
#define GL_POST_TEXTURE_FILTER_SCALE_SGIX 0x817A
#define GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX 0x817B
#define GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX 0x817C
#endif

#if GL_SGIX_framezoom
#define GL_FRAMEZOOM_SGIX                 0x818B
#define GL_FRAMEZOOM_FACTOR_SGIX          0x818C
#define GL_MAX_FRAMEZOOM_FACTOR_SGIX      0x818D
#endif

#if GL_SGIX_polynomial_ffd
#define GL_GEOMETRY_DEFORMATION_SGIX      0x8194
#define GL_TEXTURE_DEFORMATION_SGIX       0x8195
#define GL_DEFORMATIONS_MASK_SGIX         0x8196
#define GL_MAX_DEFORMATION_ORDER_SGIX     0x8197
#endif

#if GL_SGIX_reference_plane
#define GL_REFERENCE_PLANE_SGIX           0x817D
#define GL_REFERENCE_PLANE_EQUATION_SGIX  0x817E
#endif

#if GL_SGIX_depth_texture
#define GL_DEPTH_COMPONENT16_SGIX         0x81A5
#define GL_DEPTH_COMPONENT24_SGIX         0x81A6
#define GL_DEPTH_COMPONENT32_SGIX         0x81A7
#endif

#if GL_SGIX_fog_offset
#define GL_FOG_OFFSET_SGIX                0x8198
#define GL_FOG_OFFSET_VALUE_SGIX          0x8199
#endif

#if GL_SGIX_texture_add_env
#define GL_TEXTURE_ENV_BIAS_SGIX          0x80BE
#endif

#if GL_SGIX_list_priority
#define GL_LIST_PRIORITY_SGIX             0x8182
#endif

#if GL_SGIX_ir_instrument1
#define GL_IR_INSTRUMENT1_SGIX            0x817F
#endif

#if GL_SGIX_calligraphic_fragment
#define GL_CALLIGRAPHIC_FRAGMENT_SGIX     0x8183
#endif

#if GL_SGIX_texture_lod_bias
#define GL_TEXTURE_LOD_BIAS_S_SGIX        0x818E
#define GL_TEXTURE_LOD_BIAS_T_SGIX        0x818F
#define GL_TEXTURE_LOD_BIAS_R_SGIX        0x8190
#endif

#if GL_SGIX_ycrcb
#define GL_YCRCB_422_SGIX                 0x81BB
#define GL_YCRCB_444_SGIX                 0x81BC
#endif

#if GL_SGIX_fragment_lighting
#define GL_FRAGMENT_LIGHTING_SGIX         0x8400
#define GL_FRAGMENT_COLOR_MATERIAL_SGIX   0x8401
#define GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX 0x8402
#define GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX 0x8403
#define GL_MAX_FRAGMENT_LIGHTS_SGIX       0x8404
#define GL_MAX_ACTIVE_LIGHTS_SGIX         0x8405
#define GL_CURRENT_RASTER_NORMAL_SGIX     0x8406
#define GL_LIGHT_ENV_MODE_SGIX            0x8407
#define GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX 0x8408
#define GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX 0x8409
#define GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX 0x840A
#define GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX 0x840B
#define GL_FRAGMENT_LIGHT0_SGIX           0x840C
#define GL_FRAGMENT_LIGHT1_SGIX           0x840D
#define GL_FRAGMENT_LIGHT2_SGIX           0x840E
#define GL_FRAGMENT_LIGHT3_SGIX           0x840F
#define GL_FRAGMENT_LIGHT4_SGIX           0x8410
#define GL_FRAGMENT_LIGHT5_SGIX           0x8411
#define GL_FRAGMENT_LIGHT6_SGIX           0x8412
#define GL_FRAGMENT_LIGHT7_SGIX           0x8413
#endif

#if GL_SGIX_blend_alpha_minmax
#define GL_ALPHA_MIN_SGIX                 0x8320
#define GL_ALPHA_MAX_SGIX                 0x8321
#endif

#if GL_SGIX_async
#define GL_ASYNC_MARKER_SGIX              0x8329
#endif

#if GL_SGIX_async_pixel
#define GL_ASYNC_TEX_IMAGE_SGIX           0x835C
#define GL_ASYNC_DRAW_PIXELS_SGIX         0x835D
#define GL_ASYNC_READ_PIXELS_SGIX         0x835E
#define GL_MAX_ASYNC_TEX_IMAGE_SGIX       0x835F
#define GL_MAX_ASYNC_DRAW_PIXELS_SGIX     0x8360
#define GL_MAX_ASYNC_READ_PIXELS_SGIX     0x8361
#endif

#if GL_SGIX_async_histogram
#define GL_ASYNC_HISTOGRAM_SGIX           0x832C
#define GL_MAX_ASYNC_HISTOGRAM_SGIX       0x832D
#endif

#if GL_SGIX_fog_scale
#define GL_FOG_SCALE_SGIX                 0x81FC
#define GL_FOG_SCALE_VALUE_SGIX           0x81FD
#endif

#if GL_SGIX_subsample
#define GL_PACK_SUBSAMPLE_RATE_SGIX       0x85A0
#define GL_UNPACK_SUBSAMPLE_RATE_SGIX     0x85A1
#define GL_PIXEL_SUBSAMPLE_4444_SGIX      0x85A2
#define GL_PIXEL_SUBSAMPLE_2424_SGIX      0x85A3
#define GL_PIXEL_SUBSAMPLE_4242_SGIX      0x85A4
#endif

#if GL_SGIX_ycrcba
#define GL_YCRCB_SGIX                     0x8318
#define GL_YCRCBA_SGIX                    0x8319
#endif

#if GL_SGIX_vertex_preclip
#define GL_VERTEX_PRECLIP_SGIX            0x83EE
#define GL_VERTEX_PRECLIP_HINT_SGIX       0x83EF
#endif

#if GL_SGIX_convolution_accuracy
#define GL_CONVOLUTION_HINT_SGIX          0x8316
#endif

#if GL_SGIX_resample
#define GL_PACK_RESAMPLE_SGIX             0x842C
#define GL_UNPACK_RESAMPLE_SGIX           0x842D
#define GL_RESAMPLE_REPLICATE_SGIX        0x842E
#define GL_RESAMPLE_ZERO_FILL_SGIX        0x842F
#define GL_RESAMPLE_DECIMATE_SGIX         0x8430
#endif


#if GL_SUN_global_alpha
#define GL_GLOBAL_ALPHA_SUN               0x81D9
#define GL_GLOBAL_ALPHA_FACTOR_SUN        0x81DA
#endif

#if GL_SUN_triangle_list
#define GL_RESTART_SUN                    0x01
#define GL_REPLACE_MIDDLE_SUN             0x02
#define GL_REPLACE_OLDEST_SUN             0x03
#define GL_TRIANGLE_LIST_SUN              0x81D7
#define GL_REPLACEMENT_CODE_SUN           0x81D8
#define GL_REPLACEMENT_CODE_ARRAY_SUN     0x85C0
#define GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN 0x85C1
#define GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN 0x85C2
#define GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN 0x85C3
#define GL_R1UI_V3F_SUN                   0x85C4
#define GL_R1UI_C4UB_V3F_SUN              0x85C5
#define GL_R1UI_C3F_V3F_SUN               0x85C6
#define GL_R1UI_N3F_V3F_SUN               0x85C7
#define GL_R1UI_C4F_N3F_V3F_SUN           0x85C8
#define GL_R1UI_T2F_V3F_SUN               0x85C9
#define GL_R1UI_T2F_N3F_V3F_SUN           0x85CA
#define GL_R1UI_T2F_C4F_N3F_V3F_SUN       0x85CB
#endif

#if GL_SUN_convolution_border_modes
#define GL_WRAP_BORDER_SUN                0x81D4
#endif

#if GL_SUNX_constant_data
#define GL_UNPACK_CONSTANT_DATA_SUNX      0x81D5
#define GL_TEXTURE_CONSTANT_DATA_SUNX     0x81D6
#endif


#if GL_WIN_phong_shading
#define GL_PHONG_WIN                      0x80EA
#define GL_PHONG_HINT_WIN                 0x80EB
#endif

#if GL_WIN_specular_fog
#define GL_FOG_SPECULAR_TEXTURE_WIN       0x80EC
#endif


#if GL_3DFX_texture_compression_FXT1
#define GL_COMPRESSED_RGB_FXT1_3DFX       0x86B0
#define GL_COMPRESSED_RGBA_FXT1_3DFX      0x86B1
#endif

#if GL_3DFX_multisample
#define GL_MULTISAMPLE_3DFX               0x86B2
#define GL_SAMPLE_BUFFERS_3DFX            0x86B3
#define GL_SAMPLES_3DFX                   0x86B4
#define GL_MULTISAMPLE_BIT_3DFX           0x20000000
#endif


//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
// function pointer typedefs
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
#if GL_ARB_occlusion_query
typedef void (* glGenQueriesARBProcPtr) (GLsizei n, GLuint *ids);
typedef void (* glDeleteQueriesARBProcPtr) (GLsizei n, const GLuint *ids);
typedef GLboolean (* glIsQueryARBProcPtr) (GLuint id);
typedef void (* glBeginQueryARBProcPtr) (GLenum target, GLuint id);
typedef void (* glEndQueryARBProcPtr) (GLenum target);
typedef void (* glGetQueryivARBProcPtr) (GLenum target, GLenum pname, GLint *params);
typedef void (* glGetQueryObjectivARBProcPtr) (GLuint id, GLenum pname, GLint *params);
typedef void (* glGetQueryObjectuivARBProcPtr) (GLuint id, GLenum pname, GLuint *params);
#endif

#if GL_ARB_shader_objects
typedef void (* glDeleteObjectARBProcPtr) (GLhandleARB obj);
typedef GLhandleARB (* glGetHandleARBProcPtr) (GLenum pname);
typedef void (* glDetachObjectARBProcPtr) (GLhandleARB containerObj, GLhandleARB attachedObj);
typedef GLhandleARB (* glCreateShaderObjectARBProcPtr) (GLenum shaderType);
typedef void (* glShaderSourceARBProcPtr) (GLhandleARB shaderObj, GLsizei count, const GLcharARB **string, const GLint *length);
typedef void (* glCompileShaderARBProcPtr) (GLhandleARB shaderObj);
typedef GLhandleARB (* glCreateProgramObjectARBProcPtr) (void);
typedef void (* glAttachObjectARBProcPtr) (GLhandleARB containerObj, GLhandleARB obj);
typedef void (* glLinkProgramARBProcPtr) (GLhandleARB programObj);
typedef void (* glUseProgramObjectARBProcPtr) (GLhandleARB programObj);
typedef void (* glValidateProgramARBProcPtr) (GLhandleARB programObj);
typedef void (* glUniform1fARBProcPtr) (GLint location, GLfloat v0);
typedef void (* glUniform2fARBProcPtr) (GLint location, GLfloat v0, GLfloat v1);
typedef void (* glUniform3fARBProcPtr) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
typedef void (* glUniform4fARBProcPtr) (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
typedef void (* glUniform1iARBProcPtr) (GLint location, GLint v0);
typedef void (* glUniform2iARBProcPtr) (GLint location, GLint v0, GLint v1);
typedef void (* glUniform3iARBProcPtr) (GLint location, GLint v0, GLint v1, GLint v2);
typedef void (* glUniform4iARBProcPtr) (GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
typedef void (* glUniform1fvARBProcPtr) (GLint location, GLsizei count, const GLfloat *value);
typedef void (* glUniform2fvARBProcPtr) (GLint location, GLsizei count, const GLfloat *value);
typedef void (* glUniform3fvARBProcPtr) (GLint location, GLsizei count, const GLfloat *value);
typedef void (* glUniform4fvARBProcPtr) (GLint location, GLsizei count, const GLfloat *value);
typedef void (* glUniform1ivARBProcPtr) (GLint location, GLsizei count, const GLint *value);
typedef void (* glUniform2ivARBProcPtr) (GLint location, GLsizei count, const GLint *value);
typedef void (* glUniform3ivARBProcPtr) (GLint location, GLsizei count, const GLint *value);
typedef void (* glUniform4ivARBProcPtr) (GLint location, GLsizei count, const GLint *value);
typedef void (* glUniformMatrix2fvARBProcPtr) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
typedef void (* glUniformMatrix3fvARBProcPtr) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
typedef void (* glUniformMatrix4fvARBProcPtr) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
typedef void (* glGetObjectParameterfvARBProcPtr) (GLhandleARB obj, GLenum pname, GLfloat *params);
typedef void (* glGetObjectParameterivARBProcPtr) (GLhandleARB obj, GLenum pname, GLint *params);
typedef void (* glGetInfoLogARBProcPtr) (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *infoLog);
typedef void (* glGetAttachedObjectsARBProcPtr) (GLhandleARB containerObj, GLsizei maxCount, GLsizei *count, GLhandleARB *obj);
typedef GLint (* glGetUniformLocationARBProcPtr) (GLhandleARB programObj, const GLcharARB *name);
typedef void (* glGetActiveUniformARBProcPtr) (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
typedef void (* glGetUniformfvARBProcPtr) (GLhandleARB programObj, GLint location, GLfloat *params);
typedef void (* glGetUniformivARBProcPtr) (GLhandleARB programObj, GLint location, GLint *params);
typedef void (* glGetShaderSourceARBProcPtr) (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source);
#endif

#if GL_ARB_vertex_shader
typedef void (* glBindAttribLocationARBProcPtr) (GLhandleARB programObj, GLuint index, const GLcharARB *name);
typedef void (* glGetActiveAttribARBProcPtr) (GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
typedef GLint (* glGetAttribLocationARBProcPtr) (GLhandleARB programObj, const GLcharARB *name);
#endif

#if GL_ARB_vertex_buffer_object
typedef void (* glBindBufferARBProcPtr) (GLenum target, GLuint buffer);
typedef void (* glDeleteBuffersARBProcPtr) (GLsizei n, const GLuint *buffers);
typedef void (* glGenBuffersARBProcPtr) (GLsizei n, GLuint *buffers);
typedef GLboolean (* glIsBufferARBProcPtr) (GLuint buffer);
typedef void (* glBufferDataARBProcPtr) (GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage);
typedef void (* glBufferSubDataARBProcPtr) (GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid *data);
typedef void (* glGetBufferSubDataARBProcPtr) (GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data);
typedef GLvoid *(* glMapBufferARBProcPtr) (GLenum target, GLenum access);
typedef GLboolean (* glUnmapBufferARBProcPtr) (GLenum target);
typedef void (* glGetBufferParameterivARBProcPtr) (GLenum target, GLenum pname, GLint *params);
typedef void (* glGetBufferPointervARBProcPtr) (GLenum target, GLenum pname, GLvoid **params);
#endif

#if GL_ARB_draw_buffers
typedef void (* glDrawBuffersARBProcPtr) (GLsizei n, const GLenum *bufs);
#endif

#if GL_EXT_blend_color
typedef void (* glBlendColorEXTProcPtr) (GLclampf, GLclampf, GLclampf, GLclampf);
#endif


#if GL_EXT_polygon_offset
typedef void (* glPolygonOffsetEXTProcPtr) (GLfloat, GLfloat);
#endif

#if GL_EXT_texture3D
typedef void (* glTexImage3DEXTProcPtr) (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
typedef void (* glTexSubImage3DEXTProcPtr) (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
#endif

#if GL_EXT_subtexture
typedef void (* glTexSubImage1DEXTProcPtr) (GLenum, GLint, GLint, GLsizei, GLenum, GLenum, const GLvoid *);
typedef void (* glTexSubImage2DEXTProcPtr) (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
#endif

#if GL_EXT_copy_texture
typedef void (* glCopyTexImage1DEXTProcPtr) (GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLint);
typedef void (* glCopyTexImage2DEXTProcPtr) (GLenum, GLint, GLenum, GLint, GLint, GLsizei, GLsizei, GLint);
typedef void (* glCopyTexSubImage1DEXTProcPtr) (GLenum, GLint, GLint, GLint, GLint, GLsizei);
typedef void (* glCopyTexSubImage2DEXTProcPtr) (GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
typedef void (* glCopyTexSubImage3DEXTProcPtr) (GLenum, GLint, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);
#endif

#if GL_EXT_histogram
typedef void (* glGetHistogramEXTProcPtr) (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
typedef void (* glGetHistogramParameterfvEXTProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glGetHistogramParameterivEXTProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glGetMinmaxEXTProcPtr) (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
typedef void (* glGetMinmaxParameterfvEXTProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glGetMinmaxParameterivEXTProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glHistogramEXTProcPtr) (GLenum, GLsizei, GLenum, GLboolean);
typedef void (* glMinmaxEXTProcPtr) (GLenum, GLenum, GLboolean);
typedef void (* glResetHistogramEXTProcPtr) (GLenum);
typedef void (* glResetMinmaxEXTProcPtr) (GLenum);
#endif

#if GL_EXT_convolution
typedef void (* glConvolutionFilter1DEXTProcPtr) (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
typedef void (* glConvolutionFilter2DEXTProcPtr) (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
typedef void (* glConvolutionParameterfEXTProcPtr) (GLenum, GLenum, GLfloat);
typedef void (* glConvolutionParameterfvEXTProcPtr) (GLenum, GLenum, const GLfloat *);
typedef void (* glConvolutionParameteriEXTProcPtr) (GLenum, GLenum, GLint);
typedef void (* glConvolutionParameterivEXTProcPtr) (GLenum, GLenum, const GLint *);
typedef void (* glCopyConvolutionFilter1DEXTProcPtr) (GLenum, GLenum, GLint, GLint, GLsizei);
typedef void (* glCopyConvolutionFilter2DEXTProcPtr) (GLenum, GLenum, GLint, GLint, GLsizei, GLsizei);
typedef void (* glGetConvolutionFilterEXTProcPtr) (GLenum, GLenum, GLenum, GLvoid *);
typedef void (* glGetConvolutionParameterfvEXTProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glGetConvolutionParameterivEXTProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glGetSeparableFilterEXTProcPtr) (GLenum, GLenum, GLenum, GLvoid *, GLvoid *, GLvoid *);
typedef void (* glSeparableFilter2DEXTProcPtr) (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *, const GLvoid *);
#endif

#if GL_EXT_texture_object
typedef GLboolean (* glAreTexturesResidentEXTProcPtr) (GLsizei, const GLuint *, GLboolean *);
typedef void (* glBindTextureEXTProcPtr) (GLenum, GLuint);
typedef void (* glDeleteTexturesEXTProcPtr) (GLsizei, const GLuint *);
typedef void (* glGenTexturesEXTProcPtr) (GLsizei, GLuint *);
typedef GLboolean (* glIsTextureEXTProcPtr) (GLuint);
typedef void (* glPrioritizeTexturesEXTProcPtr) (GLsizei, const GLuint *, const GLclampf *);
#endif

#if GL_EXT_vertex_array
typedef void (* glArrayElementEXTProcPtr) (GLint);
typedef void (* glColorPointerEXTProcPtr) (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
typedef void (* glDrawArraysEXTProcPtr) (GLenum, GLint, GLsizei);
typedef void (* glEdgeFlagPointerEXTProcPtr) (GLsizei, GLsizei, const GLvoid *);
typedef void (* glGetPointervEXTProcPtr) (GLenum, GLvoid* *);
typedef void (* glIndexPointerEXTProcPtr) (GLenum, GLsizei, GLsizei, const GLvoid *);
typedef void (* glNormalPointerEXTProcPtr) (GLenum, GLsizei, GLsizei, const GLvoid *);
typedef void (* glTexCoordPointerEXTProcPtr) (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
typedef void (* glVertexPointerEXTProcPtr) (GLint, GLenum, GLsizei, GLsizei, const GLvoid *);
#endif

#if GL_EXT_blend_minmax
typedef void (* glBlendEquationEXTProcPtr) (GLenum);
#endif

#if GL_EXT_color_subtable
typedef void (* glCopyColorSubTableEXTProcPtr) (GLenum, GLsizei, GLint, GLint, GLsizei);
#endif

#if GL_EXT_paletted_texture
typedef void (* glColorTableEXTProcPtr) (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
typedef void (* glColorSubTableEXTProcPtr) (GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
typedef void (* glGetColorTableEXTProcPtr) (GLenum, GLenum, GLenum, GLvoid *);
typedef void (* glGetColorTableParameterivEXTProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glGetColorTableParameterfvEXTProcPtr) (GLenum, GLenum, GLfloat *);
#endif

#if GL_EXT_index_material
typedef void (* glIndexMaterialEXTProcPtr) (GLenum, GLenum);
#endif

#if GL_EXT_index_func
typedef void (* glIndexFuncEXTProcPtr) (GLenum, GLclampf);
#endif

#if GL_EXT_compiled_vertex_array
typedef void (* glLockArraysEXTProcPtr) (GLint, GLsizei);
typedef void (* glUnlockArraysEXTProcPtr) (void);
#endif

#if GL_EXT_cull_vertex
typedef void (* glCullParameterdvEXTProcPtr) (GLenum, GLdouble *);
typedef void (* glCullParameterfvEXTProcPtr) (GLenum, GLfloat *);
#endif

#if GL_EXT_draw_range_elements
typedef void (* glDrawRangeElementsEXTProcPtr) (GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
#endif

#if GL_EXT_light_texture
typedef void (* glApplyTextureEXTProcPtr) (GLenum);
typedef void (* glTextureLightEXTProcPtr) (GLenum);
typedef void (* glTextureMaterialEXTProcPtr) (GLenum, GLenum);
#endif

#if GL_EXT_pixel_transform
typedef void (* glPixelTransformParameteriEXTProcPtr) (GLenum, GLenum, GLint);
typedef void (* glPixelTransformParameterfEXTProcPtr) (GLenum, GLenum, GLfloat);
typedef void (* glPixelTransformParameterivEXTProcPtr) (GLenum, GLenum, const GLint *);
typedef void (* glPixelTransformParameterfvEXTProcPtr) (GLenum, GLenum, const GLfloat *);
#endif

#if GL_EXT_secondary_color
typedef void (* glSecondaryColor3bEXTProcPtr) (GLbyte, GLbyte, GLbyte);
typedef void (* glSecondaryColor3bvEXTProcPtr) (const GLbyte *);
typedef void (* glSecondaryColor3dEXTProcPtr) (GLdouble, GLdouble, GLdouble);
typedef void (* glSecondaryColor3dvEXTProcPtr) (const GLdouble *);
typedef void (* glSecondaryColor3fEXTProcPtr) (GLfloat, GLfloat, GLfloat);
typedef void (* glSecondaryColor3fvEXTProcPtr) (const GLfloat *);
typedef void (* glSecondaryColor3iEXTProcPtr) (GLint, GLint, GLint);
typedef void (* glSecondaryColor3ivEXTProcPtr) (const GLint *);
typedef void (* glSecondaryColor3sEXTProcPtr) (GLshort, GLshort, GLshort);
typedef void (* glSecondaryColor3svEXTProcPtr) (const GLshort *);
typedef void (* glSecondaryColor3ubEXTProcPtr) (GLubyte, GLubyte, GLubyte);
typedef void (* glSecondaryColor3ubvEXTProcPtr) (const GLubyte *);
typedef void (* glSecondaryColor3uiEXTProcPtr) (GLuint, GLuint, GLuint);
typedef void (* glSecondaryColor3uivEXTProcPtr) (const GLuint *);
typedef void (* glSecondaryColor3usEXTProcPtr) (GLushort, GLushort, GLushort);
typedef void (* glSecondaryColor3usvEXTProcPtr) (const GLushort *);
typedef void (* glSecondaryColorPointerEXTProcPtr) (GLint, GLenum, GLsizei, const GLvoid *);
#endif

#if GL_EXT_texture_perturb_normal
typedef void (* glTextureNormalEXTProcPtr) (GLenum);
#endif

#if GL_EXT_multi_draw_arrays
typedef void (* glMultiDrawArraysEXTProcPtr) (GLenum, const GLint *, const GLsizei *, GLsizei);
typedef void (* glMultiDrawElementsEXTProcPtr) (GLenum, const GLsizei *, GLenum, const GLvoid* *, GLsizei);
#endif

#if GL_EXT_fog_coord
typedef void (* glFogCoordfEXTProcPtr) (GLfloat);
typedef void (* glFogCoordfvEXTProcPtr) (const GLfloat *);
typedef void (* glFogCoorddEXTProcPtr) (GLdouble);
typedef void (* glFogCoorddvEXTProcPtr) (const GLdouble *);
typedef void (* glFogCoordPointerEXTProcPtr) (GLenum, GLsizei, const GLvoid *);
#endif

#if GL_EXT_coordinate_frame
typedef void (* glTangent3bEXTProcPtr) (GLbyte, GLbyte, GLbyte);
typedef void (* glTangent3bvEXTProcPtr) (const GLbyte *);
typedef void (* glTangent3dEXTProcPtr) (GLdouble, GLdouble, GLdouble);
typedef void (* glTangent3dvEXTProcPtr) (const GLdouble *);
typedef void (* glTangent3fEXTProcPtr) (GLfloat, GLfloat, GLfloat);
typedef void (* glTangent3fvEXTProcPtr) (const GLfloat *);
typedef void (* glTangent3iEXTProcPtr) (GLint, GLint, GLint);
typedef void (* glTangent3ivEXTProcPtr) (const GLint *);
typedef void (* glTangent3sEXTProcPtr) (GLshort, GLshort, GLshort);
typedef void (* glTangent3svEXTProcPtr) (const GLshort *);
typedef void (* glBinormal3bEXTProcPtr) (GLbyte, GLbyte, GLbyte);
typedef void (* glBinormal3bvEXTProcPtr) (const GLbyte *);
typedef void (* glBinormal3dEXTProcPtr) (GLdouble, GLdouble, GLdouble);
typedef void (* glBinormal3dvEXTProcPtr) (const GLdouble *);
typedef void (* glBinormal3fEXTProcPtr) (GLfloat, GLfloat, GLfloat);
typedef void (* glBinormal3fvEXTProcPtr) (const GLfloat *);
typedef void (* glBinormal3iEXTProcPtr) (GLint, GLint, GLint);
typedef void (* glBinormal3ivEXTProcPtr) (const GLint *);
typedef void (* glBinormal3sEXTProcPtr) (GLshort, GLshort, GLshort);
typedef void (* glBinormal3svEXTProcPtr) (const GLshort *);
typedef void (* glTangentPointerEXTProcPtr) (GLenum, GLsizei, const GLvoid *);
typedef void (* glBinormalPointerEXTProcPtr) (GLenum, GLsizei, const GLvoid *);
#endif

#if GL_EXT_blend_func_separate
typedef void (* glBlendFuncSeparateEXTProcPtr) (GLenum, GLenum, GLenum, GLenum);
#endif

#if GL_EXT_vertex_weighting
typedef void (* glVertexWeightfEXTProcPtr) (GLfloat);
typedef void (* glVertexWeightfvEXTProcPtr) (const GLfloat *);
typedef void (* glVertexWeightPointerEXTProcPtr) (GLsizei, GLenum, GLsizei, const GLvoid *);
#endif

#if GL_EXT_vertex_shader
typedef void (* glBeginVertexShaderEXTProcPtr) (void);
typedef void (* glEndVertexShaderEXTProcPtr) (void);
typedef void (* glBindVertexShaderEXTProcPtr) (GLuint id);
typedef GLuint (* glGenVertexShadersEXTProcPtr) (GLuint range);
typedef void (* glDeleteVertexShaderEXTProcPtr) (GLuint id);
typedef void (* glShaderOp1EXTProcPtr) (GLenum op, GLuint res, GLuint arg1);
typedef void (* glShaderOp2EXTProcPtr) (GLenum op, GLuint res, GLuint arg1, GLuint arg2);
typedef void (* glShaderOp3EXTProcPtr) (GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3);
typedef void (* glSwizzleEXTProcPtr) (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
typedef void (* glWriteMaskEXTProcPtr) (GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
typedef void (* glInsertComponentEXTProcPtr) (GLuint res, GLuint src, GLuint num);
typedef void (* glExtractComponentEXTProcPtr) (GLuint res, GLuint src, GLuint num);
typedef GLuint (* glGenSymbolsEXTProcPtr) (GLenum datatype, GLenum storagetype, GLenum range, GLuint components);
typedef void (* glSetInvariantEXTProcPtr) (GLuint id, GLenum type, GLvoid *addr);
typedef void (* glSetLocalConstantEXTProcPtr) (GLuint id, GLenum type, GLvoid *addr);
typedef void (* glVariantbvEXTProcPtr) (GLuint id, GLbyte *addr);
typedef void (* glVariantdvEXTProcPtr) (GLuint id, GLdouble *addr);
typedef void (* glVariantfvEXTProcPtr) (GLuint id, GLfloat *addr);
typedef void (* glVariantivEXTProcPtr) (GLuint id, GLint *addr);
typedef void (* glVariantsvEXTProcPtr) (GLuint id, GLshort *addr);
typedef void (* glVariantubvEXTProcPtr) (GLuint id, GLubyte *addr);
typedef void (* glVariantuivEXTProcPtr) (GLuint id, GLuint *addr);
typedef void (* glVariantusvEXTProcPtr) (GLuint id, GLushort *addr);
typedef void (* glVariantPointerEXTProcPtr) (GLuint id, GLenum type, GLuint stride, GLvoid *addr);
typedef void (* glEnableVariantClientStateEXTProcPtr) (GLuint id);
typedef void (* glDisableVariantClientStateEXTProcPtr) (GLuint id);
typedef GLuint (* glBindLightParameterEXTProcPtr) (GLenum light, GLenum value);
typedef GLuint (* glBindMaterialParameterEXTProcPtr) (GLenum face, GLenum value);
typedef GLuint (* glBindTexGenParameterEXTProcPtr) (GLenum unit, GLenum coord, GLenum value);
typedef GLuint (* glBindTextureUnitParameterEXTProcPtr) (GLenum unit, GLenum value);
typedef GLuint (* glBindParameterEXTProcPtr) (GLenum value);
typedef GLboolean (* glIsVariantEnabledEXTProcPtr) (GLuint id, GLenum cap);
typedef void (* glGetVariantBooleanvEXTProcPtr) (GLuint id, GLenum value, GLboolean *data);
typedef void (* glGetVariantIntegervEXTProcPtr) (GLuint id, GLenum value, GLint *data);
typedef void (* glGetVariantFloatvEXTProcPtr) (GLuint id, GLenum value, GLfloat *data);
typedef void (* glGetVariantPointervEXTProcPtr) (GLuint id, GLenum value, GLvoid **data);
typedef void (* glGetInvariantBooleanvEXTProcPtr) (GLuint id, GLenum value, GLboolean *data);
typedef void (* glGetInvariantIntegervEXTProcPtr) (GLuint id, GLenum value, GLint *data);
typedef void (* glGetInvariantFloatvEXTProcPtr) (GLuint id, GLenum value, GLfloat *data);
typedef void (* glGetLocalConstantBooleanvEXTProcPtr) (GLuint id, GLenum value, GLboolean *data);
typedef void (* glGetLocalConstantIntegervEXTProcPtr) (GLuint id, GLenum value, GLint *data);
typedef void (* glGetLocalConstantFloatvEXTProcPtr) (GLuint id, GLenum value, GLfloat *data);
#endif

#if GL_EXT_fragment_shader
typedef GLuint (* glGenFragmentShadersEXTProcPtr) (GLuint range);
typedef void (* glBindFragmentShaderEXTProcPtr) (GLuint id);
typedef void (* glDeleteFragmentShaderEXTProcPtr) (GLuint id);
typedef void (* glBeginFragmentShaderEXTProcPtr) (void);
typedef void (* glEndFragmentShaderEXTProcPtr) (void);
typedef void (* glPassTexCoordEXTProcPtr) (GLuint dst, GLuint coord, GLenum swizzle);
typedef void (* glSampleMapEXTProcPtr) (GLuint dst, GLuint interp, GLenum swizzle);
typedef void (* glColorFragmentOp1EXTProcPtr) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
typedef void (* glColorFragmentOp2EXTProcPtr) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
typedef void (* glColorFragmentOp3EXTProcPtr) (GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
typedef void (* glAlphaFragmentOp1EXTProcPtr) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
typedef void (* glAlphaFragmentOp2EXTProcPtr) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
typedef void (* glAlphaFragmentOp3EXTProcPtr) (GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
typedef void (* glSetFragmentShaderConstantEXTProcPtr) (GLuint dst, const GLfloat *value);
#endif

#if GL_EXT_multisample
typedef void (* glSampleMaskEXTProcPtr) (GLclampf, GLboolean);
typedef void (* glSamplePatternEXTProcPtr) (GLenum);
#endif

#if GL_EXT_depth_bounds_test
typedef void (* glDepthBoundsEXTProcPtr) (GLclampd zmin, GLclampd zmax);
#endif

#if GL_EXT_blend_equation_separate
typedef void (* glBlendEquationSeparateEXTProcPtr) (GLenum modeRGB, GLenum modeAlpha);
#endif

#if GL_EXT_framebuffer_object
typedef GLboolean (* glIsRenderbufferEXTProcPtr) (GLuint renderbuffer);
typedef void (* glBindRenderbufferEXTProcPtr) (GLenum target, GLuint renderbuffer);
typedef void (* glDeleteRenderbuffersEXTProcPtr) (GLsizei n, const GLuint *renderbuffers);
typedef void (* glGenRenderbuffersEXTProcPtr) (GLsizei n, GLuint *renderbuffers);
typedef void (* glRenderbufferStorageEXTProcPtr) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
typedef void (* glGetRenderbufferParameterivEXTProcPtr) (GLenum target, GLenum pname, GLint *params);
typedef GLboolean (* glIsFramebufferEXTProcPtr) (GLuint framebuffer);
typedef void (* glBindFramebufferEXTProcPtr) (GLenum target, GLuint framebuffer);
typedef void (* glDeleteFramebuffersEXTProcPtr) (GLsizei n, const GLuint *framebuffers);
typedef void (* glGenFramebuffersEXTProcPtr) (GLsizei n, GLuint *framebuffers);
typedef GLenum (* glCheckFramebufferStatusEXTProcPtr) (GLenum target);
typedef void (* glFramebufferTexture1DEXTProcPtr) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
typedef void (* glFramebufferTexture2DEXTProcPtr) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
typedef void (* glFramebufferTexture3DEXTProcPtr) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
typedef void (* glFramebufferRenderbufferEXTProcPtr) (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
typedef void (* glGetFramebufferAttachmentParameterivEXTProcPtr) (GLenum target, GLenum attachment, GLenum pname, GLint *params);
typedef void (* glGenerateMipmapEXTProcPtr) (GLenum target);
#endif

#if GL_APPLE_element_array
typedef void (* glMultiDrawElementArrayAPPLEProcPtr) (GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount);
typedef void (* glMultiDrawRangeElementArrayAPPLEProcPtr) (GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount);
#endif

#if GL_APPLE_flush_render
typedef void (* glFlushRenderAPPLEProcPtr) (void);
typedef void (* glFinishRenderAPPLEProcPtr) (void);
typedef void (* glSwapAPPLEProcPtr) (void);
#endif

#if GL_ATI_separate_stencil
typedef void (* glStencilOpSeparateATIProcPtr) (GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
typedef void (* glStencilFuncSeparateATIProcPtr) (GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask);
#endif

#if GL_HP_image_transform
typedef void (* glImageTransformParameteriHPProcPtr) (GLenum, GLenum, GLint);
typedef void (* glImageTransformParameterfHPProcPtr) (GLenum, GLenum, GLfloat);
typedef void (* glImageTransformParameterivHPProcPtr) (GLenum, GLenum, const GLint *);
typedef void (* glImageTransformParameterfvHPProcPtr) (GLenum, GLenum, const GLfloat *);
typedef void (* glGetImageTransformParameterivHPProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glGetImageTransformParameterfvHPProcPtr) (GLenum, GLenum, GLfloat *);
#endif

#if GL_IBM_multimode_draw_arrays
typedef void (* glMultiModeDrawArraysIBMProcPtr) (GLenum, const GLint *, const GLsizei *, GLsizei, GLint);
typedef void (* glMultiModeDrawElementsIBMProcPtr) (const GLenum *, const GLsizei *, GLenum, const GLvoid* *, GLsizei, GLint);
#endif

#if GL_IBM_vertex_array_lists
typedef void (* glColorPointerListIBMProcPtr) (GLint, GLenum, GLint, const GLvoid* *, GLint);
typedef void (* glSecondaryColorPointerListIBMProcPtr) (GLint, GLenum, GLint, const GLvoid* *, GLint);
typedef void (* glEdgeFlagPointerListIBMProcPtr) (GLint, const GLboolean* *, GLint);
typedef void (* glFogCoordPointerListIBMProcPtr) (GLenum, GLint, const GLvoid* *, GLint);
typedef void (* glIndexPointerListIBMProcPtr) (GLenum, GLint, const GLvoid* *, GLint);
typedef void (* glNormalPointerListIBMProcPtr) (GLenum, GLint, const GLvoid* *, GLint);
typedef void (* glTexCoordPointerListIBMProcPtr) (GLint, GLenum, GLint, const GLvoid* *, GLint);
typedef void (* glVertexPointerListIBMProcPtr) (GLint, GLenum, GLint, const GLvoid* *, GLint);
#endif

#if GL_INTEL_parallel_arrays
typedef void (* glVertexPointervINTELProcPtr) (GLint, GLenum, const GLvoid* *);
typedef void (* glNormalPointervINTELProcPtr) (GLenum, const GLvoid* *);
typedef void (* glColorPointervINTELProcPtr) (GLint, GLenum, const GLvoid* *);
typedef void (* glTexCoordPointervINTELProcPtr) (GLint, GLenum, const GLvoid* *);
#endif

#if GL_MESA_resize_buffers
typedef void (* glResizeBuffersMESAProcPtr) (void);
#endif

#if GL_NV_vertex_array_range
typedef void (* glFlushVertexArrayRangeNVProcPtr) (void);
typedef void (* glVertexArrayRangeNVProcPtr) (GLsizei, const GLvoid *);
#endif

#if GL_NV_vertex_program
typedef void (* glBindProgramNVProcPtr) (GLenum target, GLuint id);
typedef void (* glDeleteProgramsNVProcPtr) (GLsizei n, const GLuint *ids);
typedef void (* glExecuteProgramNVProcPtr) (GLenum target, GLuint id, const GLfloat *params);
typedef void (* glGenProgramsNVProcPtr) (GLsizei n, GLuint *ids);
typedef GLboolean (* glAreProgramsResidentNVProcPtr) (GLsizei n, const GLuint *ids, GLboolean *residences);
typedef void (* glRequestResidentProgramsNVProcPtr) (GLsizei n, GLuint *ids);
typedef void (* glGetProgramParameterfvNVProcPtr) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
typedef void (* glGetProgramParameterdvNVProcPtr) (GLenum target, GLuint index, GLenum pname, GLdouble *params);
typedef void (* glGetProgramivNVProcPtr) (GLuint id, GLenum pname, GLint *params);
typedef void (* glGetProgramStringNVProcPtr) (GLuint id, GLenum pname, GLubyte *program);
typedef void (* glGetTrackMatrixivNVProcPtr) (GLenum target, GLuint address, GLenum pname, GLint *params);
typedef void (* glGetVertexAttribdvNVProcPtr) (GLuint index, GLenum pname, GLdouble *params);
typedef void (* glGetVertexAttribfvNVProcPtr) (GLuint index, GLenum pname, GLfloat *params);
typedef void (* glGetVertexAttribivNVProcPtr) (GLuint index, GLenum pname, GLint *params);
typedef void (* glGetVertexAttribPointervNVProcPtr) (GLuint index, GLenum pname, GLvoid **pointer);
typedef GLboolean (* glIsProgramNVProcPtr) (GLuint id);
typedef void (* glLoadProgramNVProcPtr) (GLenum target, GLuint id, GLsizei len, const GLubyte *program);
typedef void (* glProgramParameter4fNVProcPtr) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (* glProgramParameter4dNVProcPtr) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (* glProgramParameter4dvNVProcPtr) (GLenum target, GLuint index, const GLdouble *params);
typedef void (* glProgramParameter4fvNVProcPtr) (GLenum target, GLuint index, const GLfloat *params);
typedef void (* glProgramParameters4dvNVProcPtr) (GLenum target, GLuint index, GLuint num, const GLdouble *params);
typedef void (* glProgramParameters4fvNVProcPtr) (GLenum target, GLuint index, GLuint num, const GLfloat *params);
typedef void (* glTrackMatrixNVProcPtr) (GLenum target, GLuint address, GLenum matrix, GLenum transform);
typedef void (* glVertexAttribPointerNVProcPtr) (GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
typedef void (* glVertexAttrib1sNVProcPtr) (GLuint index, GLshort x);
typedef void (* glVertexAttrib1fNVProcPtr) (GLuint index, GLfloat x);
typedef void (* glVertexAttrib1dNVProcPtr) (GLuint index, GLdouble x);
typedef void (* glVertexAttrib2sNVProcPtr) (GLuint index, GLshort x, GLshort y);
typedef void (* glVertexAttrib2fNVProcPtr) (GLuint index, GLfloat x, GLfloat y);
typedef void (* glVertexAttrib2dNVProcPtr) (GLuint index, GLdouble x, GLdouble y);
typedef void (* glVertexAttrib3sNVProcPtr) (GLuint index, GLshort x, GLshort y, GLshort z);
typedef void (* glVertexAttrib3fNVProcPtr) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
typedef void (* glVertexAttrib3dNVProcPtr) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
typedef void (* glVertexAttrib4sNVProcPtr) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
typedef void (* glVertexAttrib4fNVProcPtr) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (* glVertexAttrib4dNVProcPtr) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (* glVertexAttrib4ubNVProcPtr) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
typedef void (* glVertexAttrib1svNVProcPtr) (GLuint index, GLshort *v);
typedef void (* glVertexAttrib1fvNVProcPtr) (GLuint index, GLfloat *v);
typedef void (* glVertexAttrib1dvNVProcPtr) (GLuint index, GLdouble *v);
typedef void (* glVertexAttrib2svNVProcPtr) (GLuint index, GLshort *v);
typedef void (* glVertexAttrib2fvNVProcPtr) (GLuint index, GLfloat *v);
typedef void (* glVertexAttrib2dvNVProcPtr) (GLuint index, GLdouble *v);
typedef void (* glVertexAttrib3svNVProcPtr) (GLuint index, GLshort *v);
typedef void (* glVertexAttrib3fvNVProcPtr) (GLuint index, GLfloat *v);
typedef void (* glVertexAttrib3dvNVProcPtr) (GLuint index, GLdouble *v);
typedef void (* glVertexAttrib4svNVProcPtr) (GLuint index, GLshort *v);
typedef void (* glVertexAttrib4fvNVProcPtr) (GLuint index, GLfloat *v);
typedef void (* glVertexAttrib4dvNVProcPtr) (GLuint index, GLdouble *v);
typedef void (* glVertexAttrib4ubvNVProcPtr) (GLuint index, GLubyte *v);
typedef void (* glVertexAttribs1svNVProcPtr) (GLuint index, GLsizei n, GLshort *v);
typedef void (* glVertexAttribs1fvNVProcPtr) (GLuint index, GLsizei n, GLfloat *v);
typedef void (* glVertexAttribs1dvNVProcPtr) (GLuint index, GLsizei n, GLdouble *v);
typedef void (* glVertexAttribs2svNVProcPtr) (GLuint index, GLsizei n, GLshort *v);
typedef void (* glVertexAttribs2fvNVProcPtr) (GLuint index, GLsizei n, GLfloat *v);
typedef void (* glVertexAttribs2dvNVProcPtr) (GLuint index, GLsizei n, GLdouble *v);
typedef void (* glVertexAttribs3svNVProcPtr) (GLuint index, GLsizei n, GLshort *v);
typedef void (* glVertexAttribs3fvNVProcPtr) (GLuint index, GLsizei n, GLfloat *v);
typedef void (* glVertexAttribs3dvNVProcPtr) (GLuint index, GLsizei n, GLdouble *v);
typedef void (* glVertexAttribs4svNVProcPtr) (GLuint index, GLsizei n, GLshort *v);
typedef void (* glVertexAttribs4fvNVProcPtr) (GLuint index, GLsizei n, GLfloat *v);
typedef void (* glVertexAttribs4dvNVProcPtr) (GLuint index, GLsizei n, GLdouble *v);
typedef void (* glVertexAttribs4ubvNVProcPtr) (GLuint index, GLsizei n, GLubyte *v);
#endif

#if GL_PGI_misc_hints
typedef void (* glHintPGIProcPtr) (GLenum, GLint);
#endif

#if GL_SGI_color_table
typedef void (* glColorTableSGIProcPtr) (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
typedef void (* glColorTableParameterfvSGIProcPtr) (GLenum, GLenum, const GLfloat *);
typedef void (* glColorTableParameterivSGIProcPtr) (GLenum, GLenum, const GLint *);
typedef void (* glCopyColorTableSGIProcPtr) (GLenum, GLenum, GLint, GLint, GLsizei);
typedef void (* glGetColorTableSGIProcPtr) (GLenum, GLenum, GLenum, GLvoid *);
typedef void (* glGetColorTableParameterfvSGIProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glGetColorTableParameterivSGIProcPtr) (GLenum, GLenum, GLint *);
#endif

#if GL_SGIS_texture_filter4
typedef void (* glGetTexFilterFuncSGISProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glTexFilterFuncSGISProcPtr) (GLenum, GLenum, GLsizei, const GLfloat *);
#endif

#if GL_SGIS_pixel_texture
typedef void (* glPixelTexGenParameteriSGISProcPtr) (GLenum, GLint);
typedef void (* glPixelTexGenParameterivSGISProcPtr) (GLenum, const GLint *);
typedef void (* glPixelTexGenParameterfSGISProcPtr) (GLenum, GLfloat);
typedef void (* glPixelTexGenParameterfvSGISProcPtr) (GLenum, const GLfloat *);
typedef void (* glGetPixelTexGenParameterivSGISProcPtr) (GLenum, GLint *);
typedef void (* glGetPixelTexGenParameterfvSGISProcPtr) (GLenum, GLfloat *);
#endif

#if GL_SGIS_texture4D
typedef void (* glTexImage4DSGISProcPtr) (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
typedef void (* glTexSubImage4DSGISProcPtr) (GLenum, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
#endif

#if GL_SGIS_detail_texture
typedef void (* glDetailTexFuncSGISProcPtr) (GLenum, GLsizei, const GLfloat *);
typedef void (* glGetDetailTexFuncSGISProcPtr) (GLenum, GLfloat *);
#endif

#if GL_SGIS_sharpen_texture
typedef void (* glSharpenTexFuncSGISProcPtr) (GLenum, GLsizei, const GLfloat *);
typedef void (* glGetSharpenTexFuncSGISProcPtr) (GLenum, GLfloat *);
#endif

#if GL_SGIS_multisample
typedef void (* glSampleMaskSGISProcPtr) (GLclampf, GLboolean);
typedef void (* glSamplePatternSGISProcPtr) (GLenum);
#endif

#if GL_SGIS_fog_function
typedef void (* glFogFuncSGISProcPtr) (GLsizei, const GLfloat *);
typedef void (* glGetFogFuncSGISProcPtr) (const GLfloat *);
#endif

#if GL_SGIS_texture_color_mask
typedef void (* glTextureColorMaskSGISProcPtr) (GLboolean, GLboolean, GLboolean, GLboolean);
#endif

#if GL_SGIX_pixel_texture
typedef void (* glPixelTexGenSGIXProcPtr) (GLenum);
#endif

#if GL_SGIX_sprite
typedef void (* glSpriteParameterfSGIXProcPtr) (GLenum, GLfloat);
typedef void (* glSpriteParameterfvSGIXProcPtr) (GLenum, const GLfloat *);
typedef void (* glSpriteParameteriSGIXProcPtr) (GLenum, GLint);
typedef void (* glSpriteParameterivSGIXProcPtr) (GLenum, const GLint *);
#endif

#if GL_SGIX_instruments
typedef GLint (* glGetInstrumentsSGIXProcPtr) (void);
typedef void (* glInstrumentsBufferSGIXProcPtr) (GLsizei, GLint *);
typedef GLint (* glPollInstrumentsSGIXProcPtr) (GLint *);
typedef void (* glReadInstrumentsSGIXProcPtr) (GLint);
typedef void (* glStartInstrumentsSGIXProcPtr) (void);
typedef void (* glStopInstrumentsSGIXProcPtr) (GLint);
#endif

#if GL_SGIX_framezoom
typedef void (* glFrameZoomSGIXProcPtr) (GLint);
#endif

#if GL_SGIX_tag_sample_buffer
typedef void (* glTagSampleBufferSGIXProcPtr) (void);
#endif

#if GL_SGIX_polynomial_ffd
typedef void (* glDeformationMap3dSGIXProcPtr) (GLenum, GLdouble, GLdouble, GLint, GLint, GLdouble, GLdouble, GLint, GLint, GLdouble, GLdouble, GLint, GLint, const GLdouble *);
typedef void (* glDeformationMap3fSGIXProcPtr) (GLenum, GLfloat, GLfloat, GLint, GLint, GLfloat, GLfloat, GLint, GLint, GLfloat, GLfloat, GLint, GLint, const GLfloat *);
typedef void (* glDeformSGIXProcPtr) (GLbitfield);
typedef void (* glLoadIdentityDeformationMapSGIXProcPtr) (GLbitfield);
#endif

#if GL_SGIX_reference_plane
typedef void (* glReferencePlaneSGIXProcPtr) (const GLdouble *);
#endif

#if GL_SGIX_flush_raster
typedef void (* glFlushRasterSGIXProcPtr) (void);
#endif

#if GL_SGIX_list_priority
typedef void (* glGetListParameterfvSGIXProcPtr) (GLuint, GLenum, GLfloat *);
typedef void (* glGetListParameterivSGIXProcPtr) (GLuint, GLenum, GLint *);
typedef void (* glListParameterfSGIXProcPtr) (GLuint, GLenum, GLfloat);
typedef void (* glListParameterfvSGIXProcPtr) (GLuint, GLenum, const GLfloat *);
typedef void (* glListParameteriSGIXProcPtr) (GLuint, GLenum, GLint);
typedef void (* glListParameterivSGIXProcPtr) (GLuint, GLenum, const GLint *);
#endif

#if GL_SGIX_fragment_lighting
typedef void (* glFragmentColorMaterialSGIXProcPtr) (GLenum, GLenum);
typedef void (* glFragmentLightfSGIXProcPtr) (GLenum, GLenum, GLfloat);
typedef void (* glFragmentLightfvSGIXProcPtr) (GLenum, GLenum, const GLfloat *);
typedef void (* glFragmentLightiSGIXProcPtr) (GLenum, GLenum, GLint);
typedef void (* glFragmentLightivSGIXProcPtr) (GLenum, GLenum, const GLint *);
typedef void (* glFragmentLightModelfSGIXProcPtr) (GLenum, GLfloat);
typedef void (* glFragmentLightModelfvSGIXProcPtr) (GLenum, const GLfloat *);
typedef void (* glFragmentLightModeliSGIXProcPtr) (GLenum, GLint);
typedef void (* glFragmentLightModelivSGIXProcPtr) (GLenum, const GLint *);
typedef void (* glFragmentMaterialfSGIXProcPtr) (GLenum, GLenum, GLfloat);
typedef void (* glFragmentMaterialfvSGIXProcPtr) (GLenum, GLenum, const GLfloat *);
typedef void (* glFragmentMaterialiSGIXProcPtr) (GLenum, GLenum, GLint);
typedef void (* glFragmentMaterialivSGIXProcPtr) (GLenum, GLenum, const GLint *);
typedef void (* glGetFragmentLightfvSGIXProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glGetFragmentLightivSGIXProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glGetFragmentMaterialfvSGIXProcPtr) (GLenum, GLenum, GLfloat *);
typedef void (* glGetFragmentMaterialivSGIXProcPtr) (GLenum, GLenum, GLint *);
typedef void (* glLightEnviSGIXProcPtr) (GLenum, GLint);
#endif

#if GL_SGIX_async
typedef void (* glAsyncMarkerSGIXProcPtr) (GLuint);
typedef GLint (* glFinishAsyncSGIXProcPtr) (GLuint *);
typedef GLint (* glPollAsyncSGIXProcPtr) (GLuint *);
typedef GLuint (* glGenAsyncMarkersSGIXProcPtr) (GLsizei);
typedef void (* glDeleteAsyncMarkersSGIXProcPtr) (GLuint, GLsizei);
typedef GLboolean (* glIsAsyncMarkerSGIXProcPtr) (GLuint);
#endif

#if GL_SGIX_igloo_interface
typedef void (* glIglooInterfaceSGIXProcPtr) (GLenum, const GLvoid *);
#endif

#if GL_SUN_global_alpha
typedef void (* glGlobalAlphaFactorbSUNProcPtr) (GLbyte);
typedef void (* glGlobalAlphaFactorsSUNProcPtr) (GLshort);
typedef void (* glGlobalAlphaFactoriSUNProcPtr) (GLint);
typedef void (* glGlobalAlphaFactorfSUNProcPtr) (GLfloat);
typedef void (* glGlobalAlphaFactordSUNProcPtr) (GLdouble);
typedef void (* glGlobalAlphaFactorubSUNProcPtr) (GLubyte);
typedef void (* glGlobalAlphaFactorusSUNProcPtr) (GLushort);
typedef void (* glGlobalAlphaFactoruiSUNProcPtr) (GLuint);
#endif

#if GL_SUN_triangle_list
typedef void (* glReplacementCodeuiSUNProcPtr) (GLuint);
typedef void (* glReplacementCodeusSUNProcPtr) (GLushort);
typedef void (* glReplacementCodeubSUNProcPtr) (GLubyte);
typedef void (* glReplacementCodeuivSUNProcPtr) (const GLuint *);
typedef void (* glReplacementCodeusvSUNProcPtr) (const GLushort *);
typedef void (* glReplacementCodeubvSUNProcPtr) (const GLubyte *);
typedef void (* glReplacementCodePointerSUNProcPtr) (GLenum, GLsizei, const GLvoid* *);
#endif

#if GL_SUN_vertex
typedef void (* glColor4ubVertex2fSUNProcPtr) (GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat);
typedef void (* glColor4ubVertex2fvSUNProcPtr) (const GLubyte *, const GLfloat *);
typedef void (* glColor4ubVertex3fSUNProcPtr) (GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
typedef void (* glColor4ubVertex3fvSUNProcPtr) (const GLubyte *, const GLfloat *);
typedef void (* glColor3fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glColor3fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *);
typedef void (* glNormal3fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glNormal3fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *);
typedef void (* glColor4fNormal3fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glColor4fNormal3fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glTexCoord2fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord2fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *);
typedef void (* glTexCoord4fVertex4fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord4fVertex4fvSUNProcPtr) (const GLfloat *, const GLfloat *);
typedef void (* glTexCoord2fColor4ubVertex3fSUNProcPtr) (GLfloat, GLfloat, GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord2fColor4ubVertex3fvSUNProcPtr) (const GLfloat *, const GLubyte *, const GLfloat *);
typedef void (* glTexCoord2fColor3fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord2fColor3fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glTexCoord2fNormal3fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord2fNormal3fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glTexCoord2fColor4fNormal3fVertex3fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord2fColor4fNormal3fVertex3fvSUNProcPtr) (const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glTexCoord4fColor4fNormal3fVertex4fSUNProcPtr) (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glTexCoord4fColor4fNormal3fVertex4fvSUNProcPtr) (const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glReplacementCodeuiVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *);
typedef void (* glReplacementCodeuiColor4ubVertex3fSUNProcPtr) (GLenum, GLubyte, GLubyte, GLubyte, GLubyte, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiColor4ubVertex3fvSUNProcPtr) (const GLenum *, const GLubyte *, const GLfloat *);
typedef void (* glReplacementCodeuiColor3fVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiColor3fVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *, const GLfloat *);
typedef void (* glReplacementCodeuiNormal3fVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiNormal3fVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *, const GLfloat *);
typedef void (* glReplacementCodeuiColor4fNormal3fVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiColor4fNormal3fVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glReplacementCodeuiTexCoord2fVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiTexCoord2fVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *, const GLfloat *);
typedef void (* glReplacementCodeuiTexCoord2fNormal3fVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *, const GLfloat *, const GLfloat *);
typedef void (* glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUNProcPtr) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (* glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUNProcPtr) (const GLenum *, const GLfloat *, const GLfloat *, const GLfloat *, const GLfloat *);
#endif

#if GL_SUNX_constant_data
typedef void (* glFinishTextureSUNXProcPtr) (void);
#endif

#if GL_3DFX_tbuffer
typedef void (* glTbufferMask3DFXProcPtr) (GLuint);
#endif



//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
#pragma mark -
#if GL_ARB_occlusion_query
extern glGenQueriesARBProcPtr 	pfglGenQueriesARB;
extern glDeleteQueriesARBProcPtr 	pfglDeleteQueriesARB;
extern glIsQueryARBProcPtr 	pfglIsQueryARB;
extern glBeginQueryARBProcPtr 	pfglBeginQueryARB;
extern glEndQueryARBProcPtr 	pfglEndQueryARB;
extern glGetQueryivARBProcPtr 	pfglGetQueryivARB;
extern glGetQueryObjectivARBProcPtr 	pfglGetQueryObjectivARB;
extern glGetQueryObjectuivARBProcPtr 	pfglGetQueryObjectuivARB;
#endif	

#if GL_ARB_shader_objects
extern glDeleteObjectARBProcPtr 	pfglDeleteObjectARB;
extern glGetHandleARBProcPtr 	pfglGetHandleARB;
extern glDetachObjectARBProcPtr 	pfglDetachObjectARB;
extern glCreateShaderObjectARBProcPtr 	pfglCreateShaderObjectARB;
extern glShaderSourceARBProcPtr 	pfglShaderSourceARB;
extern glCompileShaderARBProcPtr 	pfglCompileShaderARB;
extern glCreateProgramObjectARBProcPtr 	pfglCreateProgramObjectARB;
extern glAttachObjectARBProcPtr 	pfglAttachObjectARB;
extern glLinkProgramARBProcPtr 	pfglLinkProgramARB;
extern glUseProgramObjectARBProcPtr 	pfglUseProgramObjectARB;
extern glValidateProgramARBProcPtr 	pfglValidateProgramARB;
extern glUniform1fARBProcPtr 	pfglUniform1fARB;
extern glUniform2fARBProcPtr 	pfglUniform2fARB;
extern glUniform3fARBProcPtr 	pfglUniform3fARB;
extern glUniform4fARBProcPtr 	pfglUniform4fARB;
extern glUniform1iARBProcPtr 	pfglUniform1iARB;
extern glUniform2iARBProcPtr 	pfglUniform2iARB;
extern glUniform3iARBProcPtr 	pfglUniform3iARB;
extern glUniform4iARBProcPtr	pfglUniform4iARB;
extern glUniform1fvARBProcPtr	pfglUniform1fvARB;
extern glUniform2fvARBProcPtr 	pfglUniform2fvARB;
extern glUniform3fvARBProcPtr 	pfglUniform3fvARB;
extern glUniform4fvARBProcPtr 	pfglUniform4fvARB;
extern glUniform1ivARBProcPtr 	pfglUniform1ivARB;
extern glUniform2ivARBProcPtr 	pfglUniform2ivARB;
extern glUniform3ivARBProcPtr 	pfglUniform3ivARB;
extern glUniform4ivARBProcPtr 	pfglUniform4ivARB;
extern glUniformMatrix2fvARBProcPtr 	pfglUniformMatrix2fvARB;
extern glUniformMatrix3fvARBProcPtr 	pfglUniformMatrix3fvARB;
extern glUniformMatrix4fvARBProcPtr 	pfglUniformMatrix4fvARB;
extern glGetObjectParameterfvARBProcPtr 	pfglGetObjectParameterfvARB;
extern glGetObjectParameterivARBProcPtr 	pfglGetObjectParameterivARB;
extern glGetInfoLogARBProcPtr 	pfglGetInfoLogARB;
extern glGetAttachedObjectsARBProcPtr 	pfglGetAttachedObjectsARB;
extern glGetUniformLocationARBProcPtr 	pfglGetUniformLocationARB;
extern glGetActiveUniformARBProcPtr 	pfglGetActiveUniformARB;
extern glGetUniformfvARBProcPtr 	pfglGetUniformfvARB;
extern glGetUniformivARBProcPtr 	pfglGetUniformivARB;
extern glGetShaderSourceARBProcPtr 	pfglGetShaderSourceARB;
#endif	

#if GL_ARB_vertex_shader
extern glBindAttribLocationARBProcPtr 	pfglBindAttribLocationARB; 
extern glGetActiveAttribARBProcPtr 	pfglGetActiveAttribARB; 
extern glGetAttribLocationARBProcPtr 	pfglGetAttribLocationARB; 
#endif	

#if GL_ARB_vertex_buffer_object
extern glBindBufferARBProcPtr 	pfglBindBufferARB; 
extern glDeleteBuffersARBProcPtr 	pfglDeleteBuffersARB; 
extern glGenBuffersARBProcPtr 	pfglGenBuffersARB; 
extern glIsBufferARBProcPtr 	pfglIsBufferARB; 
extern glBufferDataARBProcPtr 	pfglBufferDataARB; 
extern glBufferSubDataARBProcPtr 	pfglBufferSubDataARB; 
extern glGetBufferSubDataARBProcPtr 	pfglGetBufferSubDataARB; 
extern glMapBufferARBProcPtr 	pfglMapBufferARB; 
extern glUnmapBufferARBProcPtr 	pfglUnmapBufferARB; 
extern glGetBufferParameterivARBProcPtr 	pfglGetBufferParameterivARB; 
extern glGetBufferPointervARBProcPtr 	pfglGetBufferPointervARB; 
#endif	

#if GL_ARB_draw_buffers
extern glDrawBuffersARBProcPtr 	pfglDrawBuffersARB; 
#endif	

#if GL_EXT_blend_color
extern glBlendColorEXTProcPtr 	pfglBlendColorEXT;
#endif

#if GL_EXT_polygon_offset
extern glPolygonOffsetEXTProcPtr 	pfglPolygonOffsetEXT; 
#endif	

#if GL_EXT_texture3D
extern glTexImage3DEXTProcPtr 	pfglTexImage3DEXT; 
extern glTexSubImage3DEXTProcPtr 	pfglTexSubImage3DEXT; 
#endif	

#if GL_EXT_subtexture
extern glTexSubImage1DEXTProcPtr 	pfglTexSubImage1DEXT; 
extern glTexSubImage2DEXTProcPtr 	pfglTexSubImage2DEXT; 
#endif	

#if GL_EXT_copy_texture
extern glCopyTexImage1DEXTProcPtr 	pfglCopyTexImage1DEXT; 
extern glCopyTexImage2DEXTProcPtr 	pfglCopyTexImage2DEXT; 
extern glCopyTexSubImage1DEXTProcPtr 	pfglCopyTexSubImage1DEXT; 
extern glCopyTexSubImage2DEXTProcPtr 	pfglCopyTexSubImage2DEXT; 
extern glCopyTexSubImage3DEXTProcPtr 	pfglCopyTexSubImage3DEXT; 
#endif	

#if GL_EXT_histogram
extern glGetHistogramEXTProcPtr 	pfglGetHistogramEXT; 
extern glGetHistogramParameterfvEXTProcPtr 	pfglGetHistogramParameterfvEXT; 
extern glGetHistogramParameterivEXTProcPtr 	pfglGetHistogramParameterivEXT; 
extern glGetMinmaxEXTProcPtr 	pfglGetMinmaxEXT; 
extern glGetMinmaxParameterfvEXTProcPtr 	pfglGetMinmaxParameterfvEXT; 
extern glGetMinmaxParameterivEXTProcPtr 	pfglGetMinmaxParameterivEXT; 
extern glHistogramEXTProcPtr 	pfglHistogramEXT; 
extern glMinmaxEXTProcPtr 	pfglMinmaxEXT; 
extern glResetHistogramEXTProcPtr 	pfglResetHistogramEXT; 
extern glResetMinmaxEXTProcPtr 	pfglResetMinmaxEXT; 
#endif	

#if GL_EXT_convolution
extern glConvolutionFilter1DEXTProcPtr 	pfglConvolutionFilter1DEXT; 
extern glConvolutionFilter2DEXTProcPtr 	pfglConvolutionFilter2DEXT; 
extern glConvolutionParameterfEXTProcPtr 	pfglConvolutionParameterfEXT; 
extern glConvolutionParameterfvEXTProcPtr 	pfglConvolutionParameterfvEXT; 
extern glConvolutionParameteriEXTProcPtr 	pfglConvolutionParameteriEXT; 
extern glConvolutionParameterivEXTProcPtr 	pfglConvolutionParameterivEXT; 
extern glCopyConvolutionFilter1DEXTProcPtr 	pfglCopyConvolutionFilter1DEXT; 
extern glCopyConvolutionFilter2DEXTProcPtr 	pfglCopyConvolutionFilter2DEXT; 
extern glGetConvolutionFilterEXTProcPtr 	pfglGetConvolutionFilterEXT; 
extern glGetConvolutionParameterfvEXTProcPtr 	pfglGetConvolutionParameterfvEXT; 
extern glGetConvolutionParameterivEXTProcPtr 	pfglGetConvolutionParameterivEXT; 
extern glGetSeparableFilterEXTProcPtr 	pfglGetSeparableFilterEXT; 
extern glSeparableFilter2DEXTProcPtr 	pfglSeparableFilter2DEXT; 
#endif	

#if GL_EXT_texture_object
extern glAreTexturesResidentEXTProcPtr 	pfglAreTexturesResidentEXT; 
extern glBindTextureEXTProcPtr 	pfglBindTextureEXT; 
extern glDeleteTexturesEXTProcPtr 	pfglDeleteTexturesEXT; 
extern glGenTexturesEXTProcPtr 	pfglGenTexturesEXT; 
extern glIsTextureEXTProcPtr 	pfglIsTextureEXT; 
extern glPrioritizeTexturesEXTProcPtr 	pfglPrioritizeTexturesEXT; 
#endif	

#if GL_EXT_vertex_array
extern glArrayElementEXTProcPtr 	pfglArrayElementEXT; 
extern glColorPointerEXTProcPtr 	pfglColorPointerEXT; 
extern glDrawArraysEXTProcPtr 	pfglDrawArraysEXT; 
extern glEdgeFlagPointerEXTProcPtr 	pfglEdgeFlagPointerEXT; 
extern glGetPointervEXTProcPtr 	pfglGetPointervEXT; 
extern glIndexPointerEXTProcPtr 	pfglIndexPointerEXT; 
extern glNormalPointerEXTProcPtr 	pfglNormalPointerEXT; 
extern glTexCoordPointerEXTProcPtr 	pfglTexCoordPointerEXT; 
extern glVertexPointerEXTProcPtr 	pfglVertexPointerEXT; 
#endif	

#if GL_EXT_blend_minmax
extern glBlendEquationEXTProcPtr 	pfglBlendEquationEXT;
#endif

#if GL_EXT_color_subtable
extern glCopyColorSubTableEXTProcPtr 	pfglCopyColorSubTableEXT; 
extern glCopyColorSubTableEXTProcPtr 	pfglCopyColorSubTableEXT;
#endif	

#if GL_EXT_paletted_texture
extern glColorTableEXTProcPtr 	pfglColorTableEXT;
extern glColorSubTableEXTProcPtr 	pfglColorSubTableEXT; 
extern glGetColorTableEXTProcPtr 	pfglGetColorTableEXT;
extern glGetColorTableParameterivEXTProcPtr 	pfglGetColorTableParameterivEXT;
extern glGetColorTableParameterfvEXTProcPtr 	pfglGetColorTableParameterfvEXT;
#endif

#if GL_EXT_index_material
extern glIndexMaterialEXTProcPtr 	pfglIndexMaterialEXT; 
#endif	

#if GL_EXT_index_func
extern glIndexFuncEXTProcPtr 	pfglIndexFuncEXT; 
#endif	

#if GL_EXT_compiled_vertex_array
extern glLockArraysEXTProcPtr 	pfglLockArraysEXT; 
extern glUnlockArraysEXTProcPtr 	pfglUnlockArraysEXT; 
#endif	

#if GL_EXT_cull_vertex
extern glCullParameterdvEXTProcPtr 	pfglCullParameterdvEXT; 
extern glCullParameterfvEXTProcPtr 	pfglCullParameterfvEXT; 
#endif	

#if GL_EXT_draw_range_elements
extern glDrawRangeElementsEXTProcPtr 	pfglDrawRangeElementsEXT;
#endif

#if GL_EXT_light_texture
extern glApplyTextureEXTProcPtr 	pfglApplyTextureEXT; 
extern glTextureLightEXTProcPtr 	pfglTextureLightEXT; 
extern glTextureMaterialEXTProcPtr 	pfglTextureMaterialEXT; 
#endif	

#if GL_EXT_pixel_transform
extern glPixelTransformParameteriEXTProcPtr 	pfglPixelTransformParameteriEXT; 
extern glPixelTransformParameterfEXTProcPtr 	pfglPixelTransformParameterfEXT; 
extern glPixelTransformParameterivEXTProcPtr 	pfglPixelTransformParameterivEXT; 
extern glPixelTransformParameterfvEXTProcPtr 	pfglPixelTransformParameterfvEXT; 
#endif	

#if GL_EXT_secondary_color
extern glSecondaryColor3bEXTProcPtr 	pfglSecondaryColor3bEXT;
extern glSecondaryColor3bvEXTProcPtr 	pfglSecondaryColor3bvEXT;
extern glSecondaryColor3dEXTProcPtr 	pfglSecondaryColor3dEXT;
extern glSecondaryColor3dvEXTProcPtr 	pfglSecondaryColor3dvEXT;
extern glSecondaryColor3fEXTProcPtr 	pfglSecondaryColor3fEXT;
extern glSecondaryColor3fvEXTProcPtr 	pfglSecondaryColor3fvEXT;
extern glSecondaryColor3iEXTProcPtr 	pfglSecondaryColor3iEXT;
extern glSecondaryColor3ivEXTProcPtr 	pfglSecondaryColor3ivEXT;
extern glSecondaryColor3sEXTProcPtr 	pfglSecondaryColor3sEXT;
extern glSecondaryColor3svEXTProcPtr 	pfglSecondaryColor3svEXT;
extern glSecondaryColor3ubEXTProcPtr 	pfglSecondaryColor3ubEXT;
extern glSecondaryColor3ubvEXTProcPtr 	pfglSecondaryColor3ubvEXT;
extern glSecondaryColor3uiEXTProcPtr 	pfglSecondaryColor3uiEXT;
extern glSecondaryColor3uivEXTProcPtr 	pfglSecondaryColor3uivEXT;
extern glSecondaryColor3usEXTProcPtr 	pfglSecondaryColor3usEXT;
extern glSecondaryColor3usvEXTProcPtr 	pfglSecondaryColor3usvEXT;
extern glSecondaryColorPointerEXTProcPtr 	pfglSecondaryColorPointerEXT;
#endif

#if GL_EXT__perturb_normal
extern glTextureNormalEXTProcPtr 	pfglTextureNormalEXT; 
#endif	

#if GL_EXT_multi_draw_arrays
extern glMultiDrawArraysEXTProcPtr 	pfglMultiDrawArraysEXT;
extern glMultiDrawElementsEXTProcPtr 	pfglMultiDrawElementsEXT;
#endif

#if GL_EXT_fog_coord
extern glFogCoordfEXTProcPtr 	pfglFogCoordfEXT;
extern glFogCoordfvEXTProcPtr 	pfglFogCoordfvEXT;
extern glFogCoorddEXTProcPtr 	pfglFogCoorddEXT;
extern glFogCoorddvEXTProcPtr 	pfglFogCoorddvEXT;
extern glFogCoordPointerEXTProcPtr 	pfglFogCoordPointerEXT;
#endif

#if GL_EXT_coordinate_frame
extern glTangent3bEXTProcPtr 	pfglTangent3bEXT; 
extern glTangent3bvEXTProcPtr 	pfglTangent3bvEXT; 
extern glTangent3dEXTProcPtr 	pfglTangent3dEXT; 
extern glTangent3dvEXTProcPtr 	pfglTangent3dvEXT; 
extern glTangent3fEXTProcPtr 	pfglTangent3fEXT; 
extern glTangent3fvEXTProcPtr 	pfglTangent3fvEXT; 
extern glTangent3iEXTProcPtr 	pfglTangent3iEXT; 
extern glTangent3ivEXTProcPtr 	pfglTangent3ivEXT; 
extern glTangent3sEXTProcPtr 	pfglTangent3sEXT; 
extern glTangent3svEXTProcPtr 	pfglTangent3svEXT; 
extern glBinormal3bEXTProcPtr 	pfglBinormal3bEXT; 
extern glBinormal3bvEXTProcPtr 	pfglBinormal3bvEXT; 
extern glBinormal3dEXTProcPtr 	pfglBinormal3dEXT; 
extern glBinormal3dvEXTProcPtr 	pfglBinormal3dvEXT; 
extern glBinormal3fEXTProcPtr 	pfglBinormal3fEXT; 
extern glBinormal3fvEXTProcPtr 	pfglBinormal3fvEXT; 
extern glBinormal3iEXTProcPtr 	pfglBinormal3iEXT; 
extern glBinormal3ivEXTProcPtr 	pfglBinormal3ivEXT; 
extern glBinormal3sEXTProcPtr 	pfglBinormal3sEXT; 
extern glBinormal3svEXTProcPtr 	pfglBinormal3svEXT; 
extern glTangentPointerEXTProcPtr 	pfglTangentPointerEXT; 
extern glBinormalPointerEXTProcPtr 	pfglBinormalPointerEXT; 
#endif	

#if GL_EXT_blend_func_separate
extern glBlendFuncSeparateEXTProcPtr 	pfglBlendFuncSeparateEXT;
#endif

#if GL_EXT_vertex_weighting
extern glVertexWeightfEXTProcPtr	pfglVertexWeightfEXT;
extern glVertexWeightfvEXTProcPtr	pfglVertexWeightfvEXT;
extern glVertexWeightPointerEXTProcPtr	pfglVertexWeightPointerEXT;
#endif	

#if GL_EXT_vertex_shader
extern glBeginVertexShaderEXTProcPtr 	pfglBeginVertexShaderEXT; 
extern glEndVertexShaderEXTProcPtr 	pfglEndVertexShaderEXT; 
extern glBindVertexShaderEXTProcPtr 	pfglBindVertexShaderEXT; 
extern glGenVertexShadersEXTProcPtr 	pfglGenVertexShadersEXT; 
extern glDeleteVertexShaderEXTProcPtr 	pfglDeleteVertexShaderEXT; 
extern glShaderOp1EXTProcPtr 	pfglShaderOp1EXT; 
extern glShaderOp2EXTProcPtr 	pfglShaderOp2EXT; 
extern glShaderOp3EXTProcPtr 	pfglShaderOp3EXT; 
extern glSwizzleEXTProcPtr 	pfglSwizzleEXT; 
extern glWriteMaskEXTProcPtr 	pfglWriteMaskEXT; 
extern glInsertComponentEXTProcPtr 	pfglInsertComponentEXT; 
extern glExtractComponentEXTProcPtr 	pfglExtractComponentEXT; 
extern glGenSymbolsEXTProcPtr 	pfglGenSymbolsEXT; 
extern glSetInvariantEXTProcPtr 	pfglSetInvariantEXT; 
extern glSetLocalConstantEXTProcPtr 	pfglSetLocalConstantEXT; 
extern glVariantbvEXTProcPtr 	pfglVariantbvEXT; 
extern glVariantdvEXTProcPtr 	pfglVariantdvEXT; 
extern glVariantfvEXTProcPtr 	pfglVariantfvEXT; 
extern glVariantivEXTProcPtr 	pfglVariantivEXT; 
extern glVariantsvEXTProcPtr 	pfglVariantsvEXT; 
extern glVariantubvEXTProcPtr 	pfglVariantubvEXT; 
extern glVariantuivEXTProcPtr 	pfglVariantuivEXT; 
extern glVariantusvEXTProcPtr 	pfglVariantusvEXT; 
extern glVariantPointerEXTProcPtr 	pfglVariantPointerEXT; 
extern glEnableVariantClientStateEXTProcPtr 	pfglEnableVariantClientStateEXT; 
extern glDisableVariantClientStateEXTProcPtr 	pfglDisableVariantClientStateEXT; 
extern glBindLightParameterEXTProcPtr 	pfglBindLightParameterEXT; 
extern glBindMaterialParameterEXTProcPtr 	pfglBindMaterialParameterEXT; 
extern glBindTexGenParameterEXTProcPtr 	pfglBindTexGenParameterEXT; 
extern glBindTextureUnitParameterEXTProcPtr 	pfglBindTextureUnitParameterEXT; 
extern glBindParameterEXTProcPtr 	pfglBindParameterEXT; 
extern glIsVariantEnabledEXTProcPtr 	pfglIsVariantEnabledEXT; 
extern glGetVariantBooleanvEXTProcPtr 	pfglGetVariantBooleanvEXT; 
extern glGetVariantIntegervEXTProcPtr 	pfglGetVariantIntegervEXT; 
extern glGetVariantFloatvEXTProcPtr 	pfglGetVariantFloatvEXT; 
extern glGetVariantPointervEXTProcPtr 	pfglGetVariantPointervEXT; 
extern glGetInvariantBooleanvEXTProcPtr 	pfglGetInvariantBooleanvEXT; 
extern glGetInvariantIntegervEXTProcPtr 	pfglGetInvariantIntegervEXT; 
extern glGetInvariantFloatvEXTProcPtr 	pfglGetInvariantFloatvEXT; 
extern glGetLocalConstantBooleanvEXTProcPtr 	pfglGetLocalConstantBooleanvEXT; 
extern glGetLocalConstantIntegervEXTProcPtr 	pfglGetLocalConstantIntegervEXT; 
extern glGetLocalConstantFloatvEXTProcPtr 	pfglGetLocalConstantFloatvEXT; 
#endif	

#if GL_EXT_fragment_shader
extern glGenFragmentShadersEXTProcPtr 	pfglGenFragmentShadersEXT; 
extern glBindFragmentShaderEXTProcPtr 	pfglBindFragmentShaderEXT; 
extern glDeleteFragmentShaderEXTProcPtr 	pfglDeleteFragmentShaderEXT; 
extern glBeginFragmentShaderEXTProcPtr 	pfglBeginFragmentShaderEXT; 
extern glEndFragmentShaderEXTProcPtr 	pfglEndFragmentShaderEXT; 
extern glPassTexCoordEXTProcPtr 	pfglPassTexCoordEXT; 
extern glSampleMapEXTProcPtr 	pfglSampleMapEXT; 
extern glColorFragmentOp1EXTProcPtr 	pfglColorFragmentOp1EXT; 
extern glColorFragmentOp2EXTProcPtr 	pfglColorFragmentOp2EXT; 
extern glColorFragmentOp3EXTProcPtr 	pfglColorFragmentOp3EXT; 
extern glAlphaFragmentOp1EXTProcPtr 	pfglAlphaFragmentOp1EXT; 
extern glAlphaFragmentOp2EXTProcPtr 	pfglAlphaFragmentOp2EXT; 
extern glAlphaFragmentOp3EXTProcPtr 	pfglAlphaFragmentOp3EXT; 
extern glSetFragmentShaderConstantEXTProcPtr 	pfglSetFragmentShaderConstantEXT; 
#endif	

#if GL_EXT_multisample
extern glSampleMaskEXTProcPtr 	pfglSampleMaskEXT; 
extern glSamplePatternEXTProcPtr 	pfglSamplePatternEXT; 
#endif	

#if GL_EXT_depth_bounds_test
extern glDepthBoundsEXTProcPtr 	pfglDepthBoundsEXT; 
#endif	

#if GL_EXT_blend_equation_separate
extern glBlendEquationSeparateEXTProcPtr 	pfglBlendEquationSeparateEXT; 
#endif	

#if GL_EXT_framebuffer_object
extern glIsRenderbufferEXTProcPtr 	pfglIsRenderbufferEXT; 
extern glBindRenderbufferEXTProcPtr 	pfglBindRenderbufferEXT; 
extern glDeleteRenderbuffersEXTProcPtr 	pfglDeleteRenderbuffersEXT; 
extern glGenRenderbuffersEXTProcPtr 	pfglGenRenderbuffersEXT; 
extern glRenderbufferStorageEXTProcPtr 	pfglRenderbufferStorageEXT; 
extern glGetRenderbufferParameterivEXTProcPtr 	pfglGetRenderbufferParameterivEXT; 
extern glIsFramebufferEXTProcPtr 	pfglIsFramebufferEXT; 
extern glBindFramebufferEXTProcPtr 	pfglBindFramebufferEXT; 
extern glDeleteFramebuffersEXTProcPtr 	pfglDeleteFramebuffersEXT; 
extern glGenFramebuffersEXTProcPtr 	pfglGenFramebuffersEXT; 
extern glCheckFramebufferStatusEXTProcPtr 	pfglCheckFramebufferStatusEXT; 
extern glFramebufferTexture1DEXTProcPtr 	pfglFramebufferTexture1DEXT; 
extern glFramebufferTexture2DEXTProcPtr 	pfglFramebufferTexture2DEXT; 
extern glFramebufferTexture3DEXTProcPtr 	pfglFramebufferTexture3DEXT; 
extern glFramebufferRenderbufferEXTProcPtr 	pfglFramebufferRenderbufferEXT; 
extern glGetFramebufferAttachmentParameterivEXTProcPtr 	pfglGetFramebufferAttachmentParameterivEXT; 
extern glGenerateMipmapEXTProcPtr 	pfglGenerateMipmapEXT; 
#endif	

#if GL_APPLE_element_array
extern glMultiDrawElementArrayAPPLEProcPtr 	pfglMultiDrawElementArrayAPPLE; 
extern glMultiDrawRangeElementArrayAPPLEProcPtr 	pfglMultiDrawRangeElementArrayAPPLE; 
#endif	

#if GL_APPLE_flush_render
extern glFlushRenderAPPLEProcPtr 	pfglFlushRenderAPPLE; 
extern glFinishRenderAPPLEProcPtr 	pfglFinishRenderAPPLE; 
extern glSwapAPPLEProcPtr 	pfglSwapAPPLE; 
#endif	

#if GL_ATI_separate_stencil
extern glStencilOpSeparateATIProcPtr 	pfglStencilOpSeparateATI; 
extern glStencilFuncSeparateATIProcPtr 	pfglStencilFuncSeparateATI; 
#endif	

#if GL_HP_image_transform
extern glImageTransformParameteriHPProcPtr 	pfglImageTransformParameteriHP; 
extern glImageTransformParameterfHPProcPtr 	pfglImageTransformParameterfHP; 
extern glImageTransformParameterivHPProcPtr 	pfglImageTransformParameterivHP; 
extern glImageTransformParameterfvHPProcPtr 	pfglImageTransformParameterfvHP; 
extern glGetImageTransformParameterivHPProcPtr 	pfglGetImageTransformParameterivHP; 
extern glGetImageTransformParameterfvHPProcPtr 	pfglGetImageTransformParameterfvHP; 
#endif	

#if GL_IBM_multimode_draw_arrays
extern glMultiModeDrawArraysIBMProcPtr 	pfglMultiModeDrawArraysIBM; 
extern glMultiModeDrawElementsIBMProcPtr 	pfglMultiModeDrawElementsIBM; 
#endif	

#if GL_IBM_vertex_array_lists
extern glColorPointerListIBMProcPtr 	pfglColorPointerListIBM; 
extern glSecondaryColorPointerListIBMProcPtr 	pfglSecondaryColorPointerListIBM; 
extern glEdgeFlagPointerListIBMProcPtr 	pfglEdgeFlagPointerListIBM; 
extern glFogCoordPointerListIBMProcPtr 	pfglFogCoordPointerListIBM; 
extern glIndexPointerListIBMProcPtr 	pfglIndexPointerListIBM; 
extern glNormalPointerListIBMProcPtr 	pfglNormalPointerListIBM; 
extern glTexCoordPointerListIBMProcPtr 	pfglTexCoordPointerListIBM; 
extern glVertexPointerListIBMProcPtr 	pfglVertexPointerListIBM; 
#endif	

#if GL_INTEL_parallel_arrays
extern glVertexPointervINTELProcPtr 	pfglVertexPointervINTEL; 
extern glNormalPointervINTELProcPtr 	pfglNormalPointervINTEL; 
extern glColorPointervINTELProcPtr 	pfglColorPointervINTEL; 
extern glTexCoordPointervINTELProcPtr 	pfglTexCoordPointervINTEL; 
#endif	

#if GL_MESA_resize_buffers
extern glResizeBuffersMESAProcPtr 	pfglResizeBuffersMESA; 
#endif	

#if GL_NV_vertex_array_range
extern glFlushVertexArrayRangeNVProcPtr 	pfglFlushVertexArrayRangeNV; 
extern glVertexArrayRangeNVProcPtr 	pfglVertexArrayRangeNV; 
#endif	

#if GL_NV_vertex_program
extern glBindProgramNVProcPtr 	pfglBindProgramNV; 
extern glDeleteProgramsNVProcPtr 	pfglDeleteProgramsNV; 
extern glExecuteProgramNVProcPtr 	pfglExecuteProgramNV; 
extern glGenProgramsNVProcPtr 	pfglGenProgramsNV; 
extern glAreProgramsResidentNVProcPtr 	pfglAreProgramsResidentNV; 
extern glRequestResidentProgramsNVProcPtr 	pfglRequestResidentProgramsNV; 
extern glGetProgramParameterfvNVProcPtr 	pfglGetProgramParameterfvNV; 
extern glGetProgramParameterdvNVProcPtr 	pfglGetProgramParameterdvNV; 
extern glGetProgramivNVProcPtr 	pfglGetProgramivNV; 
extern glGetProgramStringNVProcPtr 	pfglGetProgramStringNV; 
extern glGetTrackMatrixivNVProcPtr 	pfglGetTrackMatrixivNV; 
extern glGetVertexAttribdvNVProcPtr 	pfglGetVertexAttribdvNV; 
extern glGetVertexAttribfvNVProcPtr 	pfglGetVertexAttribfvNV; 
extern glGetVertexAttribivNVProcPtr 	pfglGetVertexAttribivNV; 
extern glGetVertexAttribPointervNVProcPtr 	pfglGetVertexAttribPointervNV; 
extern glIsProgramNVProcPtr 	pfglIsProgramNV; 
extern glLoadProgramNVProcPtr 	pfglLoadProgramNV; 
extern glProgramParameter4fNVProcPtr 	pfglProgramParameter4fNV; 
extern glProgramParameter4dNVProcPtr 	pfglProgramParameter4dNV; 
extern glProgramParameter4dvNVProcPtr 	pfglProgramParameter4dvNV; 
extern glProgramParameter4fvNVProcPtr 	pfglProgramParameter4fvNV; 
extern glProgramParameters4dvNVProcPtr 	pfglProgramParameters4dvNV; 
extern glProgramParameters4fvNVProcPtr 	pfglProgramParameters4fvNV; 
extern glTrackMatrixNVProcPtr 	pfglTrackMatrixNV; 
extern glVertexAttribPointerNVProcPtr 	pfglVertexAttribPointerNV; 
extern glVertexAttrib1sNVProcPtr 	pfglVertexAttrib1sNV; 
extern glVertexAttrib1fNVProcPtr 	pfglVertexAttrib1fNV; 
extern glVertexAttrib1dNVProcPtr 	pfglVertexAttrib1dNV; 
extern glVertexAttrib2sNVProcPtr 	pfglVertexAttrib2sNV; 
extern glVertexAttrib2fNVProcPtr 	pfglVertexAttrib2fNV; 
extern glVertexAttrib2dNVProcPtr 	pfglVertexAttrib2dNV; 
extern glVertexAttrib3sNVProcPtr 	pfglVertexAttrib3sNV; 
extern glVertexAttrib3fNVProcPtr 	pfglVertexAttrib3fNV; 
extern glVertexAttrib3dNVProcPtr 	pfglVertexAttrib3dNV; 
extern glVertexAttrib4sNVProcPtr 	pfglVertexAttrib4sNV; 
extern glVertexAttrib4fNVProcPtr 	pfglVertexAttrib4fNV; 
extern glVertexAttrib4dNVProcPtr 	pfglVertexAttrib4dNV; 
extern glVertexAttrib4ubNVProcPtr 	pfglVertexAttrib4ubNV; 
extern glVertexAttrib1svNVProcPtr 	pfglVertexAttrib1svNV; 
extern glVertexAttrib1fvNVProcPtr 	pfglVertexAttrib1fvNV; 
extern glVertexAttrib1dvNVProcPtr 	pfglVertexAttrib1dvNV; 
extern glVertexAttrib2svNVProcPtr 	pfglVertexAttrib2svNV; 
extern glVertexAttrib2fvNVProcPtr 	pfglVertexAttrib2fvNV; 
extern glVertexAttrib2dvNVProcPtr 	pfglVertexAttrib2dvNV; 
extern glVertexAttrib3svNVProcPtr 	pfglVertexAttrib3svNV; 
extern glVertexAttrib3fvNVProcPtr 	pfglVertexAttrib3fvNV; 
extern glVertexAttrib3dvNVProcPtr 	pfglVertexAttrib3dvNV; 
extern glVertexAttrib4svNVProcPtr 	pfglVertexAttrib4svNV; 
extern glVertexAttrib4fvNVProcPtr 	pfglVertexAttrib4fvNV; 
extern glVertexAttrib4dvNVProcPtr 	pfglVertexAttrib4dvNV; 
extern glVertexAttrib4ubvNVProcPtr 	pfglVertexAttrib4ubvNV; 
extern glVertexAttribs1svNVProcPtr 	pfglVertexAttribs1svNV; 
extern glVertexAttribs1fvNVProcPtr 	pfglVertexAttribs1fvNV; 
extern glVertexAttribs1dvNVProcPtr 	pfglVertexAttribs1dvNV; 
extern glVertexAttribs2svNVProcPtr 	pfglVertexAttribs2svNV; 
extern glVertexAttribs2fvNVProcPtr 	pfglVertexAttribs2fvNV; 
extern glVertexAttribs2dvNVProcPtr 	pfglVertexAttribs2dvNV; 
extern glVertexAttribs3svNVProcPtr 	pfglVertexAttribs3svNV; 
extern glVertexAttribs3fvNVProcPtr 	pfglVertexAttribs3fvNV; 
extern glVertexAttribs3dvNVProcPtr 	pfglVertexAttribs3dvNV; 
extern glVertexAttribs4svNVProcPtr 	pfglVertexAttribs4svNV; 
extern glVertexAttribs4fvNVProcPtr 	pfglVertexAttribs4fvNV; 
extern glVertexAttribs4dvNVProcPtr 	pfglVertexAttribs4dvNV; 
extern glVertexAttribs4ubvNVProcPtr 	pfglVertexAttribs4ubvNV; 
#endif	

#if GL_PGI_misc_hints
extern glHintPGIProcPtr 	pfglHintPGI; 
#endif	

#if GL_SGI_color_table
extern glColorTableSGIProcPtr 	pfglColorTableSGI; 
extern glColorTableParameterfvSGIProcPtr 	pfglColorTableParameterfvSGI; 
extern glColorTableParameterivSGIProcPtr 	pfglColorTableParameterivSGI; 
extern glCopyColorTableSGIProcPtr 	pfglCopyColorTableSGI; 
extern glGetColorTableSGIProcPtr 	pfglGetColorTableSGI; 
extern glGetColorTableParameterfvSGIProcPtr 	pfglGetColorTableParameterfvSGI; 
extern glGetColorTableParameterivSGIProcPtr 	pfglGetColorTableParameterivSGI; 
#endif	

#if GL_SGIS_texture_filter4
extern glGetTexFilterFuncSGISProcPtr 	pfglGetTexFilterFuncSGIS; 
extern glTexFilterFuncSGISProcPtr 	pfglTexFilterFuncSGIS; 
#endif	

#if GL_SGIS_pixel_texture
extern glPixelTexGenParameteriSGISProcPtr 	pfglPixelTexGenParameteriSGIS; 
extern glPixelTexGenParameterivSGISProcPtr 	pfglPixelTexGenParameterivSGIS; 
extern glPixelTexGenParameterfSGISProcPtr 	pfglPixelTexGenParameterfSGIS; 
extern glPixelTexGenParameterfvSGISProcPtr 	pfglPixelTexGenParameterfvSGIS; 
extern glGetPixelTexGenParameterivSGISProcPtr 	pfglGetPixelTexGenParameterivSGIS; 
extern glGetPixelTexGenParameterfvSGISProcPtr 	pfglGetPixelTexGenParameterfvSGIS; 
#endif	

#if GL_SGIS_texture4D
extern glTexImage4DSGISProcPtr 	pfglTexImage4DSGIS; 
extern glTexSubImage4DSGISProcPtr   	pfglTexSubImage4DSGISProcPtr   
#endif	

#if GL_SGIS_detail_texture
extern glDetailTexFuncSGISProcPtr 	pfglDetailTexFuncSGIS; 
extern glGetDetailTexFuncSGISProcPtr 	pfglGetDetailTexFuncSGIS; 
#endif	

#if GL_SGIS_sharpen_texture
extern glSharpenTexFuncSGISProcPtr 	pfglSharpenTexFuncSGIS; 
extern glGetSharpenTexFuncSGISProcPtr 	pfglGetSharpenTexFuncSGIS; 
#endif	

#if GL_SGIS_multisample
extern glSampleMaskSGISProcPtr 	pfglSampleMaskSGIS; 
extern glSamplePatternSGISProcPtr 	pfglSamplePatternSGIS; 
#endif	

#if GL_SGIS_fog_function
extern glFogFuncSGISProcPtr 	pfglFogFuncSGIS; 
extern glGetFogFuncSGISProcPtr 	pfglGetFogFuncSGIS; 
#endif	

#if GL_SGIS__color_mask
extern glTextureColorMaskSGISProcPtr 	pfglTextureColorMaskSGIS; 
#endif	

#if GL_SGIX_pixel_texture
extern glPixelTexGenSGIXProcPtr 	pfglPixelTexGenSGIX; 
#endif	

#if GL_SGIX_sprite
extern glSpriteParameterfSGIXProcPtr 	pfglSpriteParameterfSGIX; 
extern glSpriteParameterfvSGIXProcPtr 	pfglSpriteParameterfvSGIX; 
extern glSpriteParameteriSGIXProcPtr 	pfglSpriteParameteriSGIX; 
extern glSpriteParameterivSGIXProcPtr 	pfglSpriteParameterivSGIX; 
#endif	

#if GL_SGIX_instruments
extern glGetInstrumentsSGIXProcPtr 	pfglGetInstrumentsSGIX; 
extern glInstrumentsBufferSGIXProcPtr 	pfglInstrumentsBufferSGIX; 
extern glPollInstrumentsSGIXProcPtr 	pfglPollInstrumentsSGIX; 
extern glReadInstrumentsSGIXProcPtr 	pfglReadInstrumentsSGIX; 
extern glStartInstrumentsSGIXProcPtr 	pfglStartInstrumentsSGIX; 
extern glStopInstrumentsSGIXProcPtr 	pfglStopInstrumentsSGIX; 
#endif	

#if GL_SGIX_framezoom
extern glFrameZoomSGIXProcPtr 	pfglFrameZoomSGIX; 
#endif	

#if GL_SGIX_tag_sample_buffer
extern glTagSampleBufferSGIXProcPtr 	pfglTagSampleBufferSGIX; 
#endif	

#if GL_SGIX_polynomial_ffd
extern glDeformationMap3dSGIXProcPtr    	pfglDeformationMap3dSGIX;
extern glDeformationMap3fSGIXProcPtr    	pfglDeformationMap3fSGIX;
extern glDeformSGIXProcPtr 	pfglDeformSGIX; 
extern glLoadIdentityDeformationMapSGIXProcPtr 	pfglLoadIdentityDeformationMapSGIX; 
#endif	

#if GL_SGIX_reference_plane
extern glReferencePlaneSGIXProcPtr 	pfglReferencePlaneSGIX; 
#endif	

#if GL_SGIX_flush_raster
extern glFlushRasterSGIXProcPtr 	pfglFlushRasterSGIX; 
#endif	

#if GL_SGIX_list_priority
extern glGetListParameterfvSGIXProcPtr 	pfglGetListParameterfvSGIX; 
extern glGetListParameterivSGIXProcPtr 	pfglGetListParameterivSGIX; 
extern glListParameterfSGIXProcPtr 	pfglListParameterfSGIX; 
extern glListParameterfvSGIXProcPtr 	pfglListParameterfvSGIX; 
extern glListParameteriSGIXProcPtr 	pfglListParameteriSGIX; 
extern glListParameterivSGIXProcPtr 	pfglListParameterivSGIX; 
#endif	

#if GL_SGIX_fragment_lighting
extern glFragmentColorMaterialSGIXProcPtr 	pfglFragmentColorMaterialSGIX; 
extern glFragmentLightfSGIXProcPtr 	pfglFragmentLightfSGIX; 
extern glFragmentLightfvSGIXProcPtr 	pfglFragmentLightfvSGIX; 
extern glFragmentLightiSGIXProcPtr 	pfglFragmentLightiSGIX; 
extern glFragmentLightivSGIXProcPtr 	pfglFragmentLightivSGIX; 
extern glFragmentLightModelfSGIXProcPtr 	pfglFragmentLightModelfSGIX; 
extern glFragmentLightModelfvSGIXProcPtr 	pfglFragmentLightModelfvSGIX; 
extern glFragmentLightModeliSGIXProcPtr 	pfglFragmentLightModeliSGIX; 
extern glFragmentLightModelivSGIXProcPtr 	pfglFragmentLightModelivSGIX; 
extern glFragmentMaterialfSGIXProcPtr 	pfglFragmentMaterialfSGIX; 
extern glFragmentMaterialfvSGIXProcPtr 	pfglFragmentMaterialfvSGIX; 
extern glFragmentMaterialiSGIXProcPtr 	pfglFragmentMaterialiSGIX; 
extern glFragmentMaterialivSGIXProcPtr 	pfglFragmentMaterialivSGIX; 
extern glGetFragmentLightfvSGIXProcPtr 	pfglGetFragmentLightfvSGIX; 
extern glGetFragmentLightivSGIXProcPtr 	pfglGetFragmentLightivSGIX; 
extern glGetFragmentMaterialfvSGIXProcPtr 	pfglGetFragmentMaterialfvSGIX; 
extern glGetFragmentMaterialivSGIXProcPtr 	pfglGetFragmentMaterialivSGIX; 
extern glLightEnviSGIXProcPtr 	pfglLightEnviSGIX; 
#endif	

#if GL_SGIX_async
extern glAsyncMarkerSGIXProcPtr 	pfglAsyncMarkerSGIX; 
extern glFinishAsyncSGIXProcPtr 	pfglFinishAsyncSGIX; 
extern glPollAsyncSGIXProcPtr 	pfglPollAsyncSGIX; 
extern glGenAsyncMarkersSGIXProcPtr 	pfglGenAsyncMarkersSGIX; 
extern glDeleteAsyncMarkersSGIXProcPtr 	pfglDeleteAsyncMarkersSGIX; 
extern glIsAsyncMarkerSGIXProcPtr 	pfglIsAsyncMarkerSGIX; 
#endif	

#if GL_SGIX_igloo_interface
extern glIextern glooInterfaceSGIXProcPtr 	pfglIextern glooInterfaceSGIX; 
#endif	

#if GL_SUN_global_alpha
extern glGlobalAlphaFactorbSUNProcPtr 	pfglGlobalAlphaFactorbSUN; 
extern glGlobalAlphaFactorsSUNProcPtr 	pfglGlobalAlphaFactorsSUN; 
extern glGlobalAlphaFactoriSUNProcPtr 	pfglGlobalAlphaFactoriSUN; 
extern glGlobalAlphaFactorfSUNProcPtr 	pfglGlobalAlphaFactorfSUN; 
extern glGlobalAlphaFactordSUNProcPtr 	pfglGlobalAlphaFactordSUN; 
extern glGlobalAlphaFactorubSUNProcPtr 	pfglGlobalAlphaFactorubSUN; 
extern glGlobalAlphaFactorusSUNProcPtr 	pfglGlobalAlphaFactorusSUN; 
extern glGlobalAlphaFactoruiSUNProcPtr 	pfglGlobalAlphaFactoruiSUN; 
#endif	

#if GL_SUN_triangle_list
extern glReplacementCodeuiSUNProcPtr 	pfglReplacementCodeuiSUN; 
extern glReplacementCodeusSUNProcPtr 	pfglReplacementCodeusSUN; 
extern glReplacementCodeubSUNProcPtr 	pfglReplacementCodeubSUN; 
extern glReplacementCodeuivSUNProcPtr 	pfglReplacementCodeuivSUN; 
extern glReplacementCodeusvSUNProcPtr 	pfglReplacementCodeusvSUN; 
extern glReplacementCodeubvSUNProcPtr 	pfglReplacementCodeubvSUN; 
extern glReplacementCodePointerSUNProcPtr 	pfglReplacementCodePointerSUN; 
#endif	

#if GL_SUN_vertex
extern glColor4ubVertex2fSUNProcPtr 	pfglColor4ubVertex2fSUN;
extern glColor4ubVertex2fvSUNProcPtr 	pfglColor4ubVertex2fvSUN;
extern glColor4ubVertex3fSUNProcPtr 	pfglColor4ubVertex3fSUN;
extern glColor4ubVertex3fvSUNProcPtr 	pfglColor4ubVertex3fvSUN;
extern glColor3fVertex3fSUNProcPtr 	pfglColor3fVertex3fSUN;
extern glColor3fVertex3fvSUNProcPtr 	pfglColor3fVertex3fvSUN;
extern glNormal3fVertex3fSUNProcPtr 	pfglNormal3fVertex3fSUN;
extern glNormal3fVertex3fvSUNProcPtr 	pfglNormal3fVertex3fvSUN;
extern glColor4fNormal3fVertex3fSUNProcPtr 	pfglColor4fNormal3fVertex3fSUN;
extern glColor4fNormal3fVertex3fvSUNProcPtr 	pfglColor4fNormal3fVertex3fvSUN;
extern glTexCoord2fVertex3fSUNProcPtr 	pfglTexCoord2fVertex3fSUN;
extern glTexCoord2fVertex3fvSUNProcPtr 	pfglTexCoord2fVertex3fvSUN;
extern glTexCoord4fVertex4fSUNProcPtr 	pfglTexCoord4fVertex4fSUN;
extern glTexCoord4fVertex4fvSUNProcPtr 	pfglTexCoord4fVertex4fvSUN;
extern glTexCoord2fColor4ubVertex3fSUNProcPtr 	pfglTexCoord2fColor4ubVertex3fSUN;
extern glTexCoord2fColor4ubVertex3fvSUNProcPtr 	pfglTexCoord2fColor4ubVertex3fvSUN;
extern glTexCoord2fColor3fVertex3fSUNProcPtr 	pfglTexCoord2fColor3fVertex3fSUN;
extern glTexCoord2fColor3fVertex3fvSUNProcPtr 	pfglTexCoord2fColor3fVertex3fvSUN;
extern glTexCoord2fNormal3fVertex3fSUNProcPtr 	pfglTexCoord2fNormal3fVertex3fSUN;
extern glTexCoord2fNormal3fVertex3fvSUNProcPtr 	pfglTexCoord2fNormal3fVertex3fvSUN;
extern glTexCoord2fColor4fNormal3fVertex3fSUNProcPtr  	pfglTexCoord2fColor4fNormal3fVertex3fSUN;
extern glTexCoord2fColor4fNormal3fVertex3fvSUNProcPtr 	pfglTexCoord2fColor4fNormal3fVertex3fvSUN;
extern glTexCoord4fColor4fNormal3fVertex4fSUNProcPtr     	pfglTexCoord4fColor4fNormal3fVertex4fSUN;
extern glTexCoord4fColor4fNormal3fVertex4fvSUNProcPtr 	pfglTexCoord4fColor4fNormal3fVertex4fvSUN;
extern glReplacementCodeuiVertex3fSUNProcPtr 	pfglReplacementCodeuiVertex3fSUN;
extern glReplacementCodeuiVertex3fvSUNProcPtr 	pfglReplacementCodeuiVertex3fvSUN;
extern glReplacementCodeuiColor4ubVertex3fSUNProcPtr 	pfglReplacementCodeuiColor4ubVertex3fSUN;
extern glReplacementCodeuiColor4ubVertex3fvSUNProcPtr 	pfglReplacementCodeuiColor4ubVertex3fvSUN;
extern glReplacementCodeuiColor3fVertex3fSUNProcPtr 	pfglReplacementCodeuiColor3fVertex3fSUN;
extern glReplacementCodeuiColor3fVertex3fvSUNProcPtr 	pfglReplacementCodeuiColor3fVertex3fvSUN; 
extern glReplacementCodeuiNormal3fVertex3fSUNProcPtr 	pfglReplacementCodeuiNormal3fVertex3fSUN;
extern glReplacementCodeuiNormal3fVertex3fvSUNProcPtr 	pfglReplacementCodeuiNormal3fVertex3fvSUN;
extern glReplacementCodeuiColor4fNormal3fVertex3fSUNProcPtr 	pfglReplacementCodeuiColor4fNormal3fVertex3fSUN;
extern glReplacementCodeuiColor4fNormal3fVertex3fvSUNProcPtr 	pfglReplacementCodeuiColor4fNormal3fVertex3fvSUN;
extern glReplacementCodeuiTexCoord2fVertex3fSUNProcPtr 	pfglReplacementCodeuiTexCoord2fVertex3fSUN;
extern glReplacementCodeuiTexCoord2fVertex3fvSUNProcPtr 	pfglReplacementCodeuiTexCoord2fVertex3fvSUN;
extern glReplacementCodeuiTexCoord2fNormal3fVertex3fSUNProcPtr 	pfglReplacementCodeuiTexCoord2fNormal3fVertex3fSUN;
extern glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUNProcPtr 	pfglReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN;
extern glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUNProcPtr   	pfglReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN;
extern glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUNProcPtr 	pfglReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN;
#endif	

#if GL_SUNX_constant_data
extern glFinishTextureSUNXProcPtr 	pfglFinishTextureSUNX; 
#endif	

#if GL_3DFX_tbuffer
extern glTbufferMask3DFXProcPtr 	pfglTbufferMask3DFX; 
#endif

/*
 * managing entry points
 */
extern OSStatus InitMissingOpenGLEntryPoints (void);
extern void DeallocMissingOpenGLEntryPoints (void);

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////


#ifdef __cplusplus
}
#endif

#endif //__CFM_OPENGL_BRIDGE__
